/***
*
* BNBT Beta 8.0 - A C++ BitTorrent Tracker
* Copyright (C) 2003-2004 Trevor Hogan
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
***/

// =Xotic= Modified Source File

#include "bnbt.h"
#include "atom.h"
#include "sort.h"
#include "tracker.h"
#include "util.h"
//Added by =Xotic=
#include "server.h"
#include "xconfig_lang.h"
// --------------------- End of Addition

void CTracker :: serverResponseIndex( struct request_t *pRequest, struct response_t *pResponse )
{
	struct bnbttv btv = UTIL_CurrentTime( );

	if( pRequest->user.iAccess & ACCESS_VIEW )
	{
		//
		// delete torrent
		//

		if( pRequest->user.iAccess & ACCESS_EDIT )
		{
			if( pRequest->mapParams.find( "del" ) != pRequest->mapParams.end( ) )
			{
				string strDelHashString = pRequest->mapParams["del"];
				string strDelHash = UTIL_StringToHash( strDelHashString );
				string strOK = pRequest->mapParams["ok"];

				if( strDelHash.empty( ) )
				{           
					// Modified by =Xotic= 
					HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["index_page"], string( CSS_INDEX ), string( ), false, false );

					pResponse->strContent += "<p class=\"delete\">" + UTIL_Xsprintf( gmapLANG_CFG["index_invalid_hash"].c_str( ), strDelHashString.c_str( ), string( "<a title=\"" + gmapLANG_CFG["navbar_index"] + "\" href=\"/index.html\">" ).c_str( ), "</a>" ) + "</p>\n";

					// Output common HTML ending
					HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_INDEX ) );
					// ---------------------- End of Modification  

					return;
				}
				else
				{
					if( strOK == "1" )
					{
						if( m_pAllowed )
						{
							// delete from disk

							CAtom *pList = m_pAllowed->getItem( strDelHash );

							if( pList && dynamic_cast<CAtomList *>( pList ) )
							{
								vector<CAtom *> vecTorrent = dynamic_cast<CAtomList *>( pList )->getValue( );

								if( vecTorrent.size( ) == 6 )
								{
									CAtom *pFileName = vecTorrent[0];

									if( pFileName )
									{
										if( m_strArchiveDir.empty( ) )
											UTIL_DeleteFile( ( m_strAllowedDir + pFileName->toString( ) ).c_str( ) );
										else
											UTIL_MoveFile( ( m_strAllowedDir + pFileName->toString( ) ).c_str( ), ( m_strArchiveDir + pFileName->toString( ) ).c_str( ) );
									}
								}
							}

							m_pAllowed->delItem( strDelHash );
							m_pDFile->delItem( strDelHash );
							deleteTag( strDelHash );

							// Modified by =Xotic=
							HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["index_page"], string( CSS_INDEX ), string( ), NOT_INDEX, CODE_200 );

							pResponse->strContent += "<p class=\"deleted\">" + UTIL_Xsprintf( gmapLANG_CFG["index_deleted_torrent"].c_str( ), strDelHashString.c_str( ), string( "<a title=\"" + gmapLANG_CFG["navbar_index"] + "\" href=\"/index.html\">" ).c_str( ), "</a>" ) + "</p>\n";

							// Output common HTML ending
							HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_INDEX ) );
							// ---------------------- End of Modification

							return;
						}
					}
					else
					{
						// Added and modified by =Xotic=
						// The Trinity Edition - Modification Begins
						// The following replaces the OK response with a YES | NO option
						// when DELETING A TORRENT
						HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["index_page"], string( CSS_INDEX ), string( ), NOT_INDEX, CODE_200 );

						pResponse->strContent += "<p class=\"delete\">" + UTIL_Xsprintf( gmapLANG_CFG["delete_torrent_q"].c_str( ), strDelHashString.c_str( ) ) + "</p>\n";
						pResponse->strContent += "<p class=\"delete\"><a title=\"" + gmapLANG_CFG["yes"] + "\"href=\"/index.html?del=" + strDelHashString + "&amp;ok=1\">" + gmapLANG_CFG["yes"] + "</a>\n";
						pResponse->strContent += "<span class=\"pipe\">|</span><a title=\"" + gmapLANG_CFG["no"] + "\" href=\"" + string( JS_BACK ) + "\">" + gmapLANG_CFG["no"] + "</a></p>\n";

						// Output common HTML ending
						HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_INDEX ) );
						// ---------------------- End of Modification

						return;
					}
				}
			}
		}

		if( m_pDFile )
		{
			if( m_pDFile->isEmpty( ) )
			{
				// Modified by =Xotic= 
				HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["index_page"], string( CSS_INDEX ), string( ), IS_INDEX, CODE_200 );

				pResponse->strContent += "<p class=\"no_files\">" + gmapLANG_CFG["index_no_files"] + "</p>\n";

				// Output common HTML ending
				HTML_Common_End( pRequest, pResponse, btv, IS_INDEX, string( CSS_INDEX ) );
				// ---------------------- End of Modification

				return;
			}

			map<string, CAtom *> *pmapDicti = m_pDFile->getValuePtr( );

			unsigned long iKeySize = (unsigned long)pmapDicti->size( );

			// add the torrents into this structure one by one and sort it afterwards

			struct torrent_t *pTorrents = new struct torrent_t[iKeySize];

			unsigned long i = 0;

			for( map<string, CAtom *> :: iterator it = pmapDicti->begin( ); it != pmapDicti->end( ); it++ )
			{
				pTorrents[i].strInfoHash = (*it).first;
				pTorrents[i].strName = gmapLANG_CFG[gmapLANG_CFG["unknown"]];
				pTorrents[i].strLowerName = gmapLANG_CFG[gmapLANG_CFG["unknown"]];
				pTorrents[i].iSeeders = 0;
				pTorrents[i].iLeechers = 0;
				pTorrents[i].iCompleted = 0;
				pTorrents[i].iTransferred = 0;
				pTorrents[i].iSize = 0;
				pTorrents[i].iFiles = 0;
				pTorrents[i].iComments = 0;
				pTorrents[i].iAverageLeft = 0;
				pTorrents[i].iAverageLeftPercent = 0;
				pTorrents[i].iMinLeft = 0;
				pTorrents[i].iMaxiLeft = 0;

				if( (*it).second->isDicti( ) )
				{
					// grab data from m_pAllowed   

					if( m_pAllowed )
					{
						CAtom *pList = m_pAllowed->getItem( pTorrents[i].strInfoHash );

						if( pList && dynamic_cast<CAtomList *>( pList ) )
						{
							vector<CAtom *> vecTorrent = dynamic_cast<CAtomList *>( pList )->getValue( );

							if( vecTorrent.size( ) == 6 )
							{
								CAtom *pFileName = vecTorrent[0];
								CAtom *pName = vecTorrent[1];
								CAtom *pAdded = vecTorrent[2];
								CAtom *pSize = vecTorrent[3];
								CAtom *pFiles = vecTorrent[4];

								if( pFileName )
									pTorrents[i].strFileName = pFileName->toString( );

								if( pName )
								{
									// stick a lower case version in strNameLower for non case sensitive searching and sorting

									pTorrents[i].strName = pName->toString( );
									pTorrents[i].strLowerName = UTIL_ToLower( pTorrents[i].strName );
								}

								if( pAdded )
									pTorrents[i].strAdded = pAdded->toString( );

								if( pSize && dynamic_cast<CAtomLong *>( pSize ) )
									pTorrents[i].iSize = dynamic_cast<CAtomLong *>( pSize )->getValue( );

								if( pFiles && dynamic_cast<CAtomInt *>( pFiles ) )
									pTorrents[i].iFiles = (unsigned int)dynamic_cast<CAtomInt *>( pFiles )->getValue( );
							}
						}

						if( m_bAllowComments )
						{
							if( m_pComments )
							{
								CAtom *pCommentList = m_pComments->getItem( pTorrents[i].strInfoHash );

								if( pCommentList && dynamic_cast<CAtomList *>( pCommentList ) )
									pTorrents[i].iComments = (unsigned int)dynamic_cast<CAtomList *>( pCommentList )->getValuePtr( )->size( );
							}
						}
					}

					// grab data from m_pTags

					if( m_pTags )
					{
						CAtom *pDicti = m_pTags->getItem( pTorrents[i].strInfoHash );

						if( pDicti && pDicti->isDicti( ) )
						{
							CAtom *pTag = ( (CAtomDicti *)pDicti )->getItem( "tag" );
							CAtom *pName = ( (CAtomDicti *)pDicti )->getItem( "name" );
							CAtom *pUploader = ( (CAtomDicti *)pDicti )->getItem( "uploader" );
							CAtom *pInfoLink = ( (CAtomDicti *)pDicti )->getItem( "infolink" );

							if( pTag )
								pTorrents[i].strTag = pTag->toString( );

							if( pName )
							{
								// this will overwrite the previous name, i.e. the filename

								pTorrents[i].strName = pName->toString( );
								pTorrents[i].strLowerName = UTIL_ToLower( pTorrents[i].strName );
							}

							if( pUploader )
								pTorrents[i].strUploader = pUploader->toString( );

							if( pInfoLink )
								pTorrents[i].strInfoLink = pInfoLink->toString( );
						}
					}

					// grab data from m_pFastCache  

					if( GetTime( ) > m_iRefreshFastCacheNext )
					{
						RefreshFastCache( );

						m_iRefreshFastCacheNext = GetTime( ) + m_iRefreshFastCacheInterval;
					}

					CAtom *pFC = m_pFastCache->getItem( (*it).first );

					if( pFC && dynamic_cast<CAtomList *>( pFC ) )
					{
						vector<CAtom *> vecList = dynamic_cast<CAtomList *>( pFC )->getValue( );

						pTorrents[i].iSeeders = dynamic_cast<CAtomInt *>( vecList[0] )->getValue( );
						pTorrents[i].iLeechers = dynamic_cast<CAtomInt *>( vecList[1] )->getValue( );
						pTorrents[i].iCompleted = dynamic_cast<CAtomInt *>( vecList[2] )->getValue( );

						if( pTorrents[i].iLeechers > 0 )
							pTorrents[i].iAverageLeft = dynamic_cast<CAtomLong *>( vecList[3] )->getValue( ) / pTorrents[i].iLeechers;

						pTorrents[i].iMinLeft = dynamic_cast<CAtomLong *>( vecList[4] )->getValue( );
						pTorrents[i].iMaxiLeft = dynamic_cast<CAtomLong *>( vecList[5] )->getValue( );
					}

					// misc calculations

					if( m_pAllowed && m_bShowTransferred )
						pTorrents[i].iTransferred = pTorrents[i].iCompleted * pTorrents[i].iSize;

					if( pTorrents[i].iSize > 0 )
						pTorrents[i].iAverageLeftPercent = (unsigned int)( ( (float)pTorrents[i].iAverageLeft / pTorrents[i].iSize ) * 100 );
				}

				i++;
			}

			string strSort = pRequest->mapParams["sort"];

			if( m_bSort )
			{
				if( !strSort.empty( ) )
				{
					int iSort = atoi( strSort.c_str( ) );

					// Modified by =Xotic=
					switch( iSort )
					{
					case SORT_ANAME:
						if( m_pAllowed && m_bShowNames )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByName );
						break;
					case SORT_ACOMPLETE:
						qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByComplete );
						break;
					case SORT_AINCOMPLETE:
						qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByDL );
						break;
					case SORT_AADDED:
						if( m_pAllowed && m_bShowAdded )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByAdded );
						break;
					case SORT_ASIZE:
						if( m_pAllowed && m_bShowSize )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortBySize );
						break;
					case SORT_AFILES:
						if( m_pAllowed && m_bShowNumFiles )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByFiles );
						break;
					case SORT_ACOMMENTS:
						if( m_pAllowed && m_bAllowComments )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByComments );
						break;
					case SORT_AAVGLEFT:
						if( m_bShowAverageLeft )
						{
							if( m_pAllowed )
							{
								if( m_bShowLeftAsProgress )
									qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByAvgLeftPercent );
								else
									qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByAvgLeftPercent );
							}
							else
								qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByAvgLeft );
						}
						break;
					case SORT_ACOMPLETED:
						if( m_bShowCompleted )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByCompleted );
						break;
					case SORT_ATRANSFERRED:
						if( m_pAllowed && m_bShowTransferred )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByTransferred );
						break;
					case SORT_ATAG:
						qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByTag );
						break;
					case SORT_AUPLOADER:
						if( m_bShowUploader )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByUploader );
						break;
					case SORT_DNAME:
						if( m_pAllowed && m_bShowNames )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByName );
						break;
					case SORT_DCOMPLETE:
						qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByComplete );
						break;
					case SORT_DINCOMPLETE:
						qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByDL );
						break;
					case SORT_DADDED:
						if( m_pAllowed && m_bShowAdded )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByAdded );
						break;
					case SORT_DSIZE:
						if( m_pAllowed && m_bShowSize )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortBySize );
						break;
					case SORT_DFILES:
						if( m_pAllowed && m_bShowNumFiles )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByFiles );
						break;
					case SORT_DCOMMENTS:
						if( m_pAllowed && m_bAllowComments )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByComments );
						break;
					case SORT_DAVGLEFT:
						if( m_bShowAverageLeft )
						{
							if( m_pAllowed )
							{
								if( m_bShowLeftAsProgress )
									qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), asortByAvgLeftPercent );
								else
									qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByAvgLeftPercent );
							}
							else
								qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByAvgLeft );
						}
						break;
					case SORT_DCOMPLETED:
						if( m_bShowCompleted )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByCompleted );
						break;
					case SORT_DTRANSFERRED:
						if( m_pAllowed && m_bShowTransferred )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByTransferred );
						break;
					case SORT_DTAG:
						qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByTag );
						break;
					case SORT_DUPLOADER:
						if( m_bShowUploader )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByUploader );
						break;
					default:
						// default action is to sort by added if we can
						if( m_pAllowed && m_bShowAdded )
							qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByAdded );
					}
					// -------------------------- End of Modification
				}
				else
				{
					// default action is to sort by added if we can

					if( m_pAllowed && m_bShowAdded )
						qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByAdded );
				}
			}
			else
			{
				// sort is disabled, but default action is to sort by added if we can

				if( m_pAllowed && m_bShowAdded )
					qsort( pTorrents, iKeySize, sizeof( struct torrent_t ), dsortByAdded );
			}

			// Modified by =Xotic=
			// Main Header
			HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["index_page"], string( CSS_INDEX ), string( ), IS_INDEX, CODE_200 );
			// --------------------------------- End of Modification

			// some preliminary search crap
			
			string strSearch = pRequest->mapParams["search"];
			string strLowerSearch = UTIL_ToLower( strSearch );
			string strSearchResp = UTIL_StringToEscaped( strSearch );

			// Modified by =Xotic
			if( !strSearch.empty( ) && m_pAllowed && m_bShowNames && m_bSearch )
				pResponse->strContent += "<p class=\"search_results\">" + UTIL_Xsprintf( gmapLANG_CFG["search_results_for"].c_str( ), string( "\"<span class=\"filtered_by\">" + UTIL_RemoveHTML( strSearch ) + "</span>\"").c_str( ) ) + "</p>\n";
			// ---------------------- End of Modification

			// filters

			string strFilter = pRequest->mapParams["filter"];

			// Added by =Xotic=
			// Sub-filtering mode
			string strMode = pRequest->mapParams["mode"];
			// ----------------------------- End of Addition

			if( !m_vecTags.empty( ) )
			{
				// Modified by =Xotic=
				pResponse->strContent += "<div class=\"index_filter\">\n\n";
				// ------------------------------ End of Modification

				bool bFound = false;

				for( vector< pair< string, string > > :: iterator i = m_vecTags.begin( ); i != m_vecTags.end( ); i++ )
				{
					if( !bFound )
						// Added by =Xotic= 
						// The Trinity Edition 7.5r3 - Modification Begins
						// The following changes the CLEAR FILTER link to read
						// CLEAR FILTER AND SEARCH RESULTS which appears before the
						// Table of Torrents
						// It also sets a CSS class "clearfilter" which can be used
						// to HIDE this link using the following CSS command 
						// .clearfilter{display:none}
						pResponse->strContent += "<p class=\"clearfilter\"><a title=\"" + gmapLANG_CFG["clear_filter_search"] + "\" href=\"/index.html\">" + gmapLANG_CFG["clear_filter_search"] + "</a></p>\n\n";
					// ------------------------------------------------- End of Modification    

					pResponse->strContent += "<a title=\"" + (*i).first + "\" href=\"/index.html?filter=" + UTIL_StringToEscaped( (*i).first );

					if( !strSort.empty( ) )
						// Modified by =Xotic=
						pResponse->strContent += "&amp;sort=" + strSort;
					// ------------------ End of Modification

					if( !strSearch.empty( ) )
						// Modified by =Xotic=
						pResponse->strContent += "&amp;search=" + strSearchResp;

					if( !strMode.empty( ) )
						pResponse->strContent += "&amp;mode=" + strMode;

					// Assigns functions to onMouseOver and onMouseOut for each Tag Image
					// Activated by setting "trinity_use_mouseovers" to 1
					// Generates code that validates with HTML 4.01 Strict
					pResponse->strContent += "\"";

					if( m_bUseMouseovers )
					{
						pResponse->strContent += " onMouseOver=\"hoverOn" + UTIL_StringToEscaped( (*i).first ) + "(); return true\"";
						pResponse->strContent += " onMouseOut=\"hoverOff" + UTIL_StringToEscaped( (*i).first ) + "(); return true\"";
					}

					pResponse->strContent += ">\n";
					// ------------------ End of Modification

					if( !(*i).second.empty( ) )
						// Modified by =Xotic=
						// Sets a TITLE parameter for each Tag Image, so that a TOOLTIP box will popup when
						// the user's mouse pointer hovers over the Tag Image.
						pResponse->strContent += "<img class=\"tag\" src=\"" + (*i).second + "\" alt=\"[" + gmapLANG_CFG["filter_by"] + ": " + UTIL_StringToEscaped( (*i).first ) + "]\" title=\"" + gmapLANG_CFG["filter_by"] + ": " + UTIL_StringToEscaped( (*i).first ) + "\" name=\"" + UTIL_StringToEscaped( (*i).first ) + "\">";
					// ------------------------------------------------- End of Modification    
					else
						pResponse->strContent += UTIL_RemoveHTML( (*i).first );

					// Modified by =Xotic=
					pResponse->strContent += "</a>\n\n";  
					// ------------------ End of Modification

					// addition by labarks

					if( ( m_iDumpRSSFileMode == 1 || m_iDumpRSSFileMode == 2 ) && !rssdump.strURL.empty( ) )
					{
						string :: size_type iExt = rssdump.strName.rfind( "." );

						string strExt;

						if( iExt != string :: npos )
							strExt = rssdump.strName.substr( iExt );

						string strRSSFile = UTIL_StripPath( rssdump.strName );

						strRSSFile = rssdump.strURL + strRSSFile.substr( 0, strRSSFile.length( ) - strExt.length( ) ) + "-" + (*i).first + strExt;

						// Modified by =Xotic=
						pResponse->strContent += "<span class=\"dash\">&nbsp;-&nbsp;</span><a class=\"rss\" href=\"" + strRSSFile + "\">" + gmapLANG_CFG["7"] + "</a>";
						// ------------------ End of Modification
					}

					// end addition

					if( i + 1 != m_vecTags.end( ) )
						// Modified by =Xotic=
						pResponse->strContent += "<span class=\"pipe\">|</span>\n";
					// ------------------ End of Modification

					bFound = true;
				}
				// Modified by =Xotic=
				pResponse->strContent += "</div>\n\n";
			}

			// Sub-filtering mode
			pResponse->strContent += "<p class=\"subfilter\">" + gmapLANG_CFG["index_subfilter"] + ": \n";

			// All
			pResponse->strContent += "<a title=\"" + gmapLANG_CFG["subfilter_all"] + "\" href=\"/index.html?";

			if( !strSort.empty( ) )
				pResponse->strContent += "&amp;sort=" + strSort;

			if( !strSearch.empty( ) )
				pResponse->strContent += "&amp;search=" + strSearchResp;

			if( !strFilter.empty( ) )
				pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

			pResponse->strContent += "\">" + gmapLANG_CFG["subfilter_all"] + "</a>\n\n";

			// Seeded
			pResponse->strContent += "<span class=\"pipe\">|</span>\n";
			pResponse->strContent += "<a title=\"" + gmapLANG_CFG["subfilter_seeded"] + "\" href=\"/index.html?mode=Seeded";

			if( !strSort.empty( ) )
				pResponse->strContent += "&amp;sort=" + strSort;

			if( !strSearch.empty( ) )
				pResponse->strContent += "&amp;search=" + strSearchResp;

			if( !strFilter.empty( ) )
				pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

			pResponse->strContent += "\">" + gmapLANG_CFG["subfilter_seeded"] + "</a>\n\n";

			// Unseeded
			pResponse->strContent += "<span class=\"pipe\">|</span>\n";
			pResponse->strContent += "<a title=\"" + gmapLANG_CFG["subfilter_unseeded"] + "\" href=\"/index.html?mode=Unseeded";

			if( !strSort.empty( ) )
				pResponse->strContent += "&amp;sort=" + strSort;

			if( !strSearch.empty( ) )
				pResponse->strContent += "&amp;search=" + strSearchResp;

			if( !strFilter.empty( ) )
				pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

			pResponse->strContent += "\">" + gmapLANG_CFG["subfilter_unseeded"] + "</a>\n\n";

			// MyTorrents
			if ( pRequest->user.iAccess & ACCESS_UPLOAD )
			{
				pResponse->strContent += "<span class=\"pipe\">|</span>\n";
				pResponse->strContent += "<a title=\"" + gmapLANG_CFG["subfilter_mytorrents"] + "\" href=\"/index.html?mode=MyTorrents";

				if( !strSort.empty( ) )
					pResponse->strContent += "&amp;sort=" + strSort;

				if( !strSearch.empty( ) )
					pResponse->strContent += "&amp;search=" + strSearchResp;

				if( !strFilter.empty( ) )
					pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

				pResponse->strContent += "\">" + gmapLANG_CFG["subfilter_mytorrents"] + "</a>\n\n";
			}

			pResponse->strContent += "</p>\n\n";
			// --------------------------- End of Modification

			// which page are we viewing

			unsigned int iStart = 0;

			if( m_iPerPage > 0 )
			{
				string strPage = pRequest->mapParams["page"];

				if( !strPage.empty( ) )
					iStart = atoi( strPage.c_str( ) ) * m_iPerPage;

				// Added and modified by =Xotic=
				// Count matching torrents for top of page
				int iFound = 0;

				for( unsigned long i = 0; i < iKeySize; i++ )
				{
					if( !strFilter.empty( ) )
					{
						// only count entries that match the filter
						if( pTorrents[i].strTag != strFilter )
							continue;
					}

					if( !strSearch.empty( ) )
					{
						// only count entries that match the search
						if( pTorrents[i].strLowerName.find( strLowerSearch ) == string :: npos )
							continue;
					}


					// check seeded/unseeded torrents
					if( !strMode.empty( ) )
					{
						// only count entries that match the mode
						if( strMode == "Seeded" )
						{
							if( !pTorrents[i].iSeeders )
								continue;
						}
						else if( strMode == "Unseeded"  )
						{
							if( pTorrents[i].iSeeders )
								continue;
						}
						else if( ( strMode == "MyTorrents"  ) && ( pRequest->user.iAccess & ACCESS_UPLOAD ) )
						{
							if( pTorrents[i].strUploader != pRequest->user.strLogin )
								continue;
						}
					}

					iFound++;
				}

				// search, filter and count messages
				pResponse->strContent += "<p class=\"search_filter\">\n";

				if( !strSearch.empty() )
					pResponse->strContent += "<span class=\"search_results_alt\">" + gmapLANG_CFG["result_search"] + ": \"</span><span class=\"filtered_by\">" + UTIL_RemoveHTML( strSearch ) + "</span>\"\n";

				if( !strSearch.empty() && !strFilter.empty() )
					pResponse->strContent += "<span class=\"search_results_alt\"> - </span>\n";

				if( !strFilter.empty() )
					pResponse->strContent += "<span class=\"search_results_alt\">" + gmapLANG_CFG["result_filter"] + ": \"</span><span class=\"filtered_by\">" + UTIL_RemoveHTML( strFilter ) + "</span>\"\n";

				if( ( !strSearch.empty() || !strFilter.empty() ) && !strMode.empty() )
					pResponse->strContent += "<span class=\"search_results_alt\"> - </span>\n";

				if( !strMode.empty() )
					pResponse->strContent += "<span class=\"search_results_alt\">" + gmapLANG_CFG["result_subfilter"] + ": \"</span><span class=\"filtered_by\">" + UTIL_RemoveHTML( strMode ) + "</span>\"\n";

				pResponse->strContent += "</p>\n\n";

				// Modified by =Xotic=
				switch( iFound )
				{
				case 0:
					pResponse->strContent += "<p class=\"results\">" + gmapLANG_CFG["result_none_found"] + "</p>\n\n";
					break;
				case 1:
					pResponse->strContent += "<p class=\"results\">" + gmapLANG_CFG["result_1_found"] + "</p>\n\n";
					break;
				default:
					// Results found
					pResponse->strContent += "<p class=\"results\">" + UTIL_Xsprintf( gmapLANG_CFG["result_x_found"].c_str( ), CAtomInt( iFound ).toString( ).c_str( ) ) + "</p>\n\n";
				}

				// The Trinity Edition - Modification Begins
				// The following code changes "Page" to "You are viewing page" which appears before the current page number
				// It also creates an internal document link, called "Jump to Page Navigation and Torrent Search" that will
				// bring the user to the bottom of the Table of Torrents
				// Sets a CSS class "pagenavjumplink" which can be used to HIDE this link
				// using the following CSS command: .pagenavjumplink{display:none}
				pResponse->strContent += "<p class=\"pagenum_top\"> " + UTIL_Xsprintf( gmapLANG_CFG["viewing_page_num"].c_str( ), CAtomInt( ( iStart / m_iPerPage ) + 1 ).toString( ).c_str( ) );
				pResponse->strContent += "<span class=\"pagenavjumplinkpipe\">|</span><span class=\"pagenavjumplink\"><a title=\"" + gmapLANG_CFG["index_jump"] + "\" href=\"#search\">" + gmapLANG_CFG["index_jump"] + "</a></span></p>\n\n";
				// ------------------------------------------------- End of Modification    

				// Top search
				if( m_pAllowed && m_bShowNames && m_bSearch )
				{
					pResponse->strContent += "<form class=\"search_index_top\" name=\"topsearch\" method=\"get\" action=\"/index.html\">\n";

					if( !strSort.empty( ) )
						pResponse->strContent += "<p><input name=\"sort\" type=hidden value=\"" + strSort + "\"></p>\n";

					if( !strFilter.empty( ) )
						pResponse->strContent += "<p><input name=\"filter\" type=hidden value=\"" + strFilter + "\"></p>\n";

					if( !strMode.empty( ) )
						pResponse->strContent += "<p><input name=\"mode\" type=hidden value=\"" + strMode + "\"></p>\n";

					pResponse->strContent += "<p><label for=\"toptorrentsearch\">" + gmapLANG_CFG["torrent_search"] + "</label> <input name=\"search\" id=\"toptorrentsearch\" alt=\"[" + gmapLANG_CFG["torrent_search"] + "]\" type=text size=40> <a title=\"" + gmapLANG_CFG["clear_filter_search"] + "\" href=\"/index.html\">" + gmapLANG_CFG["clear_filter_search"] + "</a></p>\n";

					pResponse->strContent += "</form>\n\n";
				}

				// page numbers
				if( m_iPerPage > 0 )
				{
					pResponse->strContent += "<p class=\"pagenum_top_bar\">" + gmapLANG_CFG["jump_to_page"] + ": \n";

					for( unsigned long i = 0; i < (unsigned int)iFound; i += m_iPerPage )
					{
						pResponse->strContent += " ";

						// don't link to current page
						if( i != iStart )
						{
							pResponse->strContent += "<a title=\"" + gmapLANG_CFG["jump_to_page"] + ": " + CAtomInt( ( i / m_iPerPage ) + 1 ).toString( ) + "\" href=\"/index.html?page=" + CAtomInt( i / m_iPerPage ).toString( );

							if( !strSort.empty( ) )
								pResponse->strContent += "&amp;sort=" + strSort;

							if( !strSearch.empty( ) )
								pResponse->strContent += "&amp;search=" + strSearchResp;

							if( !strFilter.empty( ) )
								pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

							if( !strMode.empty( ) )
								pResponse->strContent += "&amp;mode=" + strMode;

							pResponse->strContent += "\">";
						}

						pResponse->strContent += CAtomInt( ( i / m_iPerPage ) + 1 ).toString( );

						if( i != iStart )
							pResponse->strContent += "</a>\n";

						// don't display a bar after the last page
						if( i + (unsigned int)m_iPerPage < (unsigned int)iFound )
							pResponse->strContent += "\n<span class=\"pipe\">|</span>";
					}

					pResponse->strContent += "</p>\n\n";
				}   
				// -------------------------- End of Modification 
			}

			bool bFound = false;

			int iAdded = 0;
			int iSkipped = 0;

			// for correct page numbers after searching

			int iFound = 0;

			for( unsigned long i = 0; i < iKeySize; i++ )
			{
				if( !strFilter.empty( ) )  
				{    
					// only display entries that match the filter  

					if( pTorrents[i].strTag != strFilter )
						continue;
				}

				if( !strSearch.empty( ) )
				{
					// only display entries that match the search   

					if( pTorrents[i].strLowerName.find( strLowerSearch ) == string :: npos )
						continue;
				}

				// Added by =Xotic=
				// check seeded/unseeded torrents
				if( !strMode.empty( ) )
				{
					// only display entries that match the mode
					if( strMode == "Seeded" )
					{
						if( !pTorrents[i].iSeeders )
							continue;
					}
					else if( strMode == "Unseeded"  )
					{
						if( pTorrents[i].iSeeders )
							continue;
					}
					else if(( strMode == "MyTorrents"  ) && ( pRequest->user.iAccess & ACCESS_UPLOAD ) )
					{
						if( pTorrents[i].strUploader != pRequest->user.strLogin )
							continue;
					}
				}
				// ----------------------- End of Addition

				iFound++;

				if( m_iPerPage == 0 || iAdded < m_iPerPage )
				{
					if( !bFound )
					{
						// output table headers

						// Added by =Xotic=
						// The following code sets a CSS class "torrent_table" using a <table> tag that can be used
						// to HIDE the entire Table of Torrents using the following CSS command:
						// table.torrent_table{display:none}
						pResponse->strContent += "<table class=\"torrent_table\" summary=\"files\">\n";

						pResponse->strContent += "<tr>\n";
						// ------------------------------------------------- End of Modification

						// <th> tag

						if( !m_vecTags.empty( ) )     
							// Modified by =Xotic=
						{
							pResponse->strContent += "<th class=\"tag\" id=\"tagheader\">" + gmapLANG_CFG["tag"];
							if( m_bSort )
							{
								pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_tag_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_ATAG;

								if( !strSearch.empty( ) )
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_tag_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DTAG;

								if( !strSearch.empty( ) )
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
							}

							pResponse->strContent += "</th>\n";
						}         
						// ------------------------------ End of Modification

						// <th> info hash

						if( m_bShowInfoHash )
							// Modified by =Xotic=
							pResponse->strContent += "<th class=\"hash\" id=\"hashheader\">" + gmapLANG_CFG["info_hash"] + "</th>\n";
						// ------------------------------ End of Modification

						// <th> name

						if( m_pAllowed && m_bShowNames )
						{
							// Modified by =Xotic=
							pResponse->strContent += "<th class=\"name\" id=\"nameheader\">" + gmapLANG_CFG["name"];
							// ------------------------------ End of Modification

							if( m_bSort )
							{
								pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_name_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_ANAME;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;
								// ------------------------------ End of Modification

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// ------------------------ End of Modification

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_name_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DNAME;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;
								// ------------------------------ End of Modification

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// ------------------------------ End of Modification

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
							}

							// Modified by =Xotic=
							pResponse->strContent += "</th>\n";
							// ------------------------------ End of Modification
						}

						// <th> torrent    

						if( m_pAllowed && m_bAllowTorrentDownloads && ( pRequest->user.iAccess & ACCESS_DL ) )
							// Modified by =Xotic=
							pResponse->strContent += "<th class=\"download\" id=\"downloadheader\">" + gmapLANG_CFG["torrent"] + "</th>\n";
						// ------------------------------ End of Modification

						// <th> comments

						if( m_pAllowed && m_bAllowComments )
						{
							if( m_pComments )
							{
								// Modified by =Xotic=
								pResponse->strContent += "<th class=\"number\" id=\"commentsheader\">" + gmapLANG_CFG["comments"];
								// ------------------------------ End of Modification

								if( m_bSort )
								{
									pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_comments_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_ACOMMENTS;

									if( !strSearch.empty( ) )
										// Modified by =Xotic=
										pResponse->strContent += "&amp;search=" + strSearchResp;
									// ------------------------------ End of Modification

									if( !strFilter.empty( ) )
										// Modified by =Xotic=
										pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

									if( !strMode.empty( ) )
										pResponse->strContent += "&amp;mode=" + strMode;
									// ------------------------------ End of Modification

									pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_comments_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DCOMMENTS;

									if( !strSearch.empty( ) )
										// Modified by =Xotic=
										pResponse->strContent += "&amp;search=" + strSearchResp;
									// ------------------------------ End of Modification

									if( !strFilter.empty( ) )
										// Modified by =Xotic=
										pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

									if( !strMode.empty( ) )
										pResponse->strContent += "&amp;mode=" + strMode;
									// ------------------------------ End of Modification

									pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
								}

								// Modified by =Xotic=
								pResponse->strContent += "</th>\n";
								// ------------------------------ End of Modification
							}
						}

						// <th> added

						if( m_pAllowed && m_bShowAdded )
						{
							// Modified by =Xotic=
							pResponse->strContent += "<th class=\"date\" id=\"addedheader\">" + gmapLANG_CFG["added"];

							if( m_bSort )
							{
								pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_added_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_AADDED;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// --------------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_added_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DADDED;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// --------------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
							}

							// Modified by =Xotic=
							pResponse->strContent += "</th>\n";
						}

						// <th> size

						if( m_pAllowed && m_bShowSize )
						{
							// Modified by =Xotic=
							pResponse->strContent += "<th class=\"bytes\" id=\"sizeheader\">" + gmapLANG_CFG["size"];

							if( m_bSort )
							{
								pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_size_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_ASIZE;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// ----------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_size_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DSIZE;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// ------------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
							}

							// Modified by =Xotic=
							pResponse->strContent += "</th>\n";
						}

						// <th> files

						if( m_pAllowed && m_bShowNumFiles )
						{
							// Modified by =Xotic=
							pResponse->strContent += "<th class=\"number\" id=\"filesheader\">" + gmapLANG_CFG["files"];

							if( m_bSort )
							{
								pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_files_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_AFILES;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// ------------------------------ End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_files_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DFILES;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// -------------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
							}

							// Modified by =Xotic=
							pResponse->strContent += "</th>\n";
						}

						// <th> seeders

						// Modified by =Xotic=
						pResponse->strContent += "<th class=\"number\" id=\"seedersheader\">" + gmapLANG_CFG["seeders"];

						if( m_bSort )
						{
							pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_seeders_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_ACOMPLETE;

							if( !strSearch.empty( ) )
								// Modified by =Xotic=
								pResponse->strContent += "&amp;search=" + strSearchResp;

							if( !strFilter.empty( ) )
								// Modified by =Xotic=
								pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

							if( !strMode.empty( ) )
								pResponse->strContent += "&amp;mode=" + strMode;
							// ---------------------------- End of Addition

							pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_seeders_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DCOMPLETE;

							if( !strSearch.empty( ) )
								// Modified by =Xotic=
								pResponse->strContent += "&amp;search=" + strSearchResp;

							if( !strFilter.empty( ) )
								// Modified by =Xotic=
								pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

							if( !strMode.empty( ) )
								pResponse->strContent += "&amp;mode=" + strMode;
							// ---------------------------- End of Addition

							pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
						}

						// Modified by =Xotic=
						pResponse->strContent += "</th>\n";

						// <th> leechers

						// Modified by =Xotic=
						pResponse->strContent += "<th class=\"number\" id=\"leechersheader\">" + gmapLANG_CFG["leechers"];

						if( m_bSort )
						{
							pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_leechers_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_AINCOMPLETE;

							if( !strSearch.empty( ) )
								// Modified by =Xotic=
								pResponse->strContent += "&amp;search=" + strSearchResp;

							if( !strFilter.empty( ) )
								// Modified by =Xotic=
								pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

							if( !strMode.empty( ) )
								pResponse->strContent += "&amp;mode=" + strMode;
							// ------------------------- End of Addition

							pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_leechers_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DINCOMPLETE;

							if( !strSearch.empty( ) )
								// Modified by =Xotic=
								pResponse->strContent += "&amp;search=" + strSearchResp;

							if( !strFilter.empty( ) )
								// Modified by =Xotic=
								pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

							if( !strMode.empty( ) )
								pResponse->strContent += "&amp;mode=" + strMode;
							// -------------------------- End of Addition

							pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
						}

						// Modified by =Xotic=
						pResponse->strContent += "</th>\n";

						// <th> completed

						if( m_bShowCompleted )
						{
							// Modified by =Xotic=
							pResponse->strContent += "<th class=\"number\" id=\"completedheader\">" + gmapLANG_CFG["completed"];

							if( m_bSort )
							{
								pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_completed_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_ACOMPLETED;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// -------------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_completed_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DCOMPLETED;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// -------------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
							}

							// Modified by =Xotic=
							pResponse->strContent += "</th>\n";
						}

						// <th> transferred

						if( m_pAllowed && m_bShowTransferred )
						{
							// Modified by =Xotic=
							pResponse->strContent += "<th class=\"bytes\" id=\"transferredheader\">" + gmapLANG_CFG["transferred"];

							if( m_bSort )
							{
								pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_transferred_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_ATRANSFERRED;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// ------------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_transferred_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DTRANSFERRED;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// -------------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
							}

							// Modified by =Xotic=
							pResponse->strContent += "</th>\n";
						}

						// <th> min left

						if( m_bShowMinLeft )
						{
							if( m_pAllowed && m_bShowLeftAsProgress )
								// Modified by =Xotic=
								pResponse->strContent += "<th class=\"percent\" id=\"minprogressheader\">" + gmapLANG_CFG["min_progress"] + "</th>\n";
							else
								// Modified by =Xotic=
								pResponse->strContent += "<th class=\"percent\" id=\"minleftheader\">" + gmapLANG_CFG["min_left"] + "</th>\n";
						}

						// <th> average left

						if( m_bShowAverageLeft )
						{
							if( m_pAllowed && m_bShowLeftAsProgress )
								// Modified by =Xotic=
								pResponse->strContent += "<th class=\"percent\" id=\"avgprogressheader\">" + gmapLANG_CFG["avg_progress"];
							else
								// Modified by =Xotic=
								pResponse->strContent += "<th class=\"percent\" id=\"avgleftheader\">" + gmapLANG_CFG["avg_left"];

							if( m_bSort )
							{
								pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_avgleft_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_AAVGLEFT;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// ------------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_avgleft_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DAVGLEFT;

								if( !strSearch.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									// Modified by =Xotic=
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;
								// ------------------------- End of Addition

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
							}

							// Modified by =Xotic=
							pResponse->strContent += "</th>\n";
						}

						// <th> maxi left

						if( m_bShowMaxiLeft )
						{
							if( m_pAllowed && m_bShowLeftAsProgress )
								// Modified by =Xotic=
								pResponse->strContent += "<th class=\"percent\" id=\"maxprogressheader\">" + gmapLANG_CFG["max_progress"] + "</th>\n";
							else
								// Modified by =Xotic=
								pResponse->strContent += "<th class=\"percent\" id=\"maxleftheader\">" + gmapLANG_CFG["max_left"] + "</th>\n";
						}

						// <th> uploader

						if( m_bShowUploader )
							// Modified by =Xotic=
						{
							pResponse->strContent += "<th class=\"uploader\" id=\"uploaderheader\">" + gmapLANG_CFG["uploader"];
							if( m_bSort )
							{
								pResponse->strContent += "<br><div><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_uploader_ascending"] + "\" href=\"/index.html?sort=" + SORTSTR_AUPLOADER;

								if( !strSearch.empty( ) )
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a class=\"sort\" title=\"" + gmapLANG_CFG["sort_uploader_descending"] + "\" href=\"/index.html?sort=" + SORTSTR_DUPLOADER;

								if( !strSearch.empty( ) )
									pResponse->strContent += "&amp;search=" + strSearchResp;

								if( !strFilter.empty( ) )
									pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

								if( !strMode.empty( ) )
									pResponse->strContent += "&amp;mode=" + strMode;

								pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a></div>";
							}

							pResponse->strContent += "</th>\n";
						}
						// ------------------------- End of Addition

						// <th> info link

						if( m_bAllowInfoLink )
							// Modified by =Xotic=
							pResponse->strContent += "<th class=\"infolink\" id=\"infolinkheader\">" + gmapLANG_CFG["info"] + "</th>\n";

						// <th> admin

						if( pRequest->user.iAccess & ACCESS_EDIT )
						{
							if( m_pAllowed )
								// Modified by =Xotic=
								pResponse->strContent += "<th id=\"adminheader\">" + gmapLANG_CFG["admin"] + "</th>\n";   
						}

						pResponse->strContent += "</tr>\n";

						bFound = true;
					}

					if( iSkipped == (int)iStart )
					{
						// output table rows

						if( iAdded % 2 )
							// Modified by =Xotic=
							pResponse->strContent += "<tr class=\"even\">\n";
						else
							// Modified by =Xotic=
							pResponse->strContent += "<tr class=\"odd\">\n";

						// <td> tag 

						if( !m_vecTags.empty( ) )
						{
							// Modified by =Xotic=
							pResponse->strContent += "<td>";

							string strTemp = pTorrents[i].strTag;

							for( vector< pair< string, string > > :: iterator j = m_vecTags.begin( ); j != m_vecTags.end( ); j++ )
							{
								if( (*j).first == pTorrents[i].strTag && !(*j).second.empty( ) )
									// Modified by =Xotic=
								{
									pResponse->strContent += "<a title=\"" + gmapLANG_CFG["filter_by"] + ": " + pTorrents[i].strTag + "\" href=\"/index.html?filter=" + UTIL_StringToEscaped( (*j).first );

									if( !strSort.empty( ) )
										pResponse->strContent += "&amp;sort=" + strSort;

									if( !strSearch.empty( ) )
										pResponse->strContent += "&amp;search=" + strSearchResp;

									if( !strMode.empty( ) )
										pResponse->strContent += "&amp;mode=" + strMode;

									// Assigns functions to onMouseOver and onMouseOut for each Tag Image
									// Activated by setting "trinity_use_mouseovers" to 1
									// Generates code that validates with HTML 4.01 Strict
									pResponse->strContent += "\"";

									if( m_bUseMouseovers )
									{
										pResponse->strContent += " onMouseOver=\"hoverOn" + UTIL_StringToEscaped( (*j).first ) + "(); return true\"";
										pResponse->strContent += " onMouseOut=\"hoverOff" + UTIL_StringToEscaped( (*j).first ) + "(); return true\"";
									}

									pResponse->strContent += ">\n";

									if( !(*j).second.empty( ) )
										// Modified by =Xotic=
										// Sets a TITLE parameter for each Tag Image, so that a TOOLTIP box will popup when
										// the user's mouse pointer hovers over the Tag Image.
										pResponse->strContent += "<img src=\"" + (*j).second + "\" alt=\"[" + gmapLANG_CFG["filter_by"] + ": "+ pTorrents[i].strTag + "]\" title=\"" + gmapLANG_CFG["filter_by"] + ": " + pTorrents[i].strTag + "\" name=\"x" + pTorrents[i].strTag + "\">";
									else
										pResponse->strContent += UTIL_RemoveHTML( pTorrents[i].strTag );

									pResponse->strContent += "</a>";
								}
							}

							pResponse->strContent += "</td>\n";
							// ------------------------ End of Modification

						}

						// <td> info hash

						if( m_bShowInfoHash )
						{
							pResponse->strContent += "<td class=\"hash\">";

							if( m_bShowStats )
								pResponse->strContent += "<a class=\"stats\" title=\"" + gmapLANG_CFG["info_hash"] + ": " + UTIL_HashToString( pTorrents[i].strInfoHash ) + "\" href=\"/stats.html?info_hash=" + UTIL_HashToString( pTorrents[i].strInfoHash ) + "\">";

							pResponse->strContent += UTIL_HashToString( pTorrents[i].strInfoHash );

							if( m_bShowStats )
								pResponse->strContent += "</a>";

							// Modified by =Xotic=
							pResponse->strContent += "</td>\n";
						}

						// <td> name

						if( m_pAllowed && m_bShowNames )
						{
							pResponse->strContent += "<td class=\"name\">";

							if( m_bShowStats )
								pResponse->strContent += "<a class=\"stats\" title=\"" + gmapLANG_CFG["name"] + ": " + UTIL_RemoveHTML( pTorrents[i].strName ) + "\" href=\"/stats.html?info_hash=" + UTIL_HashToString( pTorrents[i].strInfoHash ) + "\">";

							pResponse->strContent += UTIL_RemoveHTML( pTorrents[i].strName );

							if( m_bShowStats )
								pResponse->strContent += "</a>";

							// Modified by =Xotic=
							pResponse->strContent += "</td>\n";
						}

						// <td> torrent

						if( m_pAllowed && m_bAllowTorrentDownloads && ( pRequest->user.iAccess & ACCESS_DL ) )
						{
							// Modified by =Xotic=
							// The Trinity Edition - Modification Begins
							// The following adds "[" and "]" around the DL (download) link
							if( m_strExternalTorrentDir.empty( ) )
							{
								pResponse->strContent += "<td class=\"download\">[<a class=\"download\" title=\"" + UTIL_HashToString( pTorrents[i].strInfoHash ) + ".torrent\" href=\"";
								pResponse->strContent += "/torrents/" + UTIL_HashToString( pTorrents[i].strInfoHash ) + ".torrent";
							}
							else
							{
								pResponse->strContent += "<td class=\"download\">[<a class=\"download\" title=\"" + UTIL_HashToString( pTorrents[i].strFileName ) + "\" href=\"";
								pResponse->strContent += m_strExternalTorrentDir + UTIL_StringToEscapedStrict( pTorrents[i].strFileName );
							}

							pResponse->strContent += "\">" + gmapLANG_CFG["download"] + "</a>]</td>\n";
							// ------------------------------------------------- End of Modification                            
						}

						// <td> comments

						if( m_pAllowed && m_bAllowComments )
						{
							if( m_pComments )
								// Modified by =Xotic=
								pResponse->strContent += "<td class=\"number\"><a title=\"" + gmapLANG_CFG["comments"] + ": " + UTIL_RemoveHTML( pTorrents[i].strName ) + "\" href=\"/comments.html?info_hash=" + UTIL_HashToString( pTorrents[i].strInfoHash ) + "\">" + CAtomInt( pTorrents[i].iComments ).toString( ) + "</a></td>\n";
						}

						// <td> added

						if( m_pAllowed && m_bShowAdded )
						{
							pResponse->strContent += "<td class=\"date\">";

							if( !pTorrents[i].strAdded.empty( ) )
							{
								// strip year and seconds from time

								pResponse->strContent += pTorrents[i].strAdded.substr( 5, pTorrents[i].strAdded.size( ) - 8 );
							}

							// Modified by =Xotic=
							pResponse->strContent += "</td>\n";
						}

						// <td> size

						if( m_pAllowed && m_bShowSize )
							// Modified by =Xotic=
							pResponse->strContent += "<td class=\"bytes\">" + UTIL_BytesToString( pTorrents[i].iSize ) + "</td>\n";

						// <td> files

						if( m_pAllowed && m_bShowNumFiles )
							// Modified by =Xotic=
							pResponse->strContent += "<td class=\"number\">" + CAtomInt( pTorrents[i].iFiles ).toString( ) + "</td>\n";

						// <td> seeders

						pResponse->strContent += "<td class=\"number_";

						if( pTorrents[i].iSeeders == 0 )
							pResponse->strContent += "red\">";
						else if( pTorrents[i].iSeeders < 5 )
							pResponse->strContent += "yellow\">";
						else
							pResponse->strContent += "green\">";

						// Modified by =Xotic=
						pResponse->strContent += CAtomInt( pTorrents[i].iSeeders ).toString( ) + "</td>\n";

						// <td> leechers

						pResponse->strContent += "<td class=\"number_";

						if( pTorrents[i].iLeechers == 0 )
							pResponse->strContent += "red\">";
						else if( pTorrents[i].iLeechers < 5 )
							pResponse->strContent += "yellow\">";
						else
							pResponse->strContent += "green\">";

						// Modified by =Xotic=
						pResponse->strContent += CAtomInt( pTorrents[i].iLeechers ).toString( ) + "</td>\n";

						// <td> completed

						if( m_bShowCompleted )
							// Modified by =Xotic=
							pResponse->strContent += "<td class=\"number\">" + CAtomInt( pTorrents[i].iCompleted ).toString( ) + "</td>\n";

						// <td> transferred

						if( m_pAllowed && m_bShowTransferred )
							// Modified by =Xotic=
							pResponse->strContent += "<td class=\"bytes\">" + UTIL_BytesToString( pTorrents[i].iTransferred ) + "</td>\n";

						// <td> min left

						if( m_bShowMinLeft )
						{
							pResponse->strContent += "<td class=\"percent\">";

							if( pTorrents[i].iLeechers == 0 )
								// Modified by =Xotic=
								pResponse->strContent += gmapLANG_CFG["na"];
							else
							{
								if( m_pAllowed )
								{
									int iPercent = 0;

									if( pTorrents[i].iSize > 0 )
									{
										if( m_bShowLeftAsProgress )
											iPercent = 100 - (int)( ( (float)pTorrents[i].iMaxiLeft / pTorrents[i].iSize ) * 100 );
										else
											iPercent = (int)( ( (float)pTorrents[i].iMinLeft / pTorrents[i].iSize ) * 100 );
									}

									// Modified by =Xotic=
									pResponse->strContent += CAtomInt( iPercent ).toString( ) + "%";
								}
								else
									pResponse->strContent += UTIL_BytesToString( pTorrents[i].iMinLeft );
							}
							// Modified by =Xotic=
							pResponse->strContent += "</td>\n";
						}

						// <td> average left

						if( m_bShowAverageLeft )
						{
							pResponse->strContent += "<td class=\"percent\">";

							if( pTorrents[i].iLeechers == 0 )
								// Modified by =Xotic=
								pResponse->strContent += gmapLANG_CFG["na"];
							else
							{
								if( m_pAllowed )
								{
									int iPercent;

									if( m_bShowLeftAsProgress )
										iPercent = 100 - pTorrents[i].iAverageLeftPercent;
									else
										iPercent = pTorrents[i].iAverageLeftPercent;

									pResponse->strContent += CAtomInt( iPercent ).toString( ) + "%";

									if( !imagefill.strName.empty( ) && !imagetrans.strName.empty( ) )
									{
										pResponse->strContent += "<br>";

										if( iPercent > 0 )
										{
											// Modified by =Xotic=
											if( !imagefill.strURL.empty( ) )
												pResponse->strContent += "<img class=\"percent\" src=\"" + imagefill.strURL + imagefill.strName + "\" width=" + CAtomInt( iPercent ).toString( ) + " height=8 alt=\"[" + gmapLANG_CFG["completed"] + "]\" name=\"Completed\" title=\"" + gmapLANG_CFG["completed"] + "\">";
											else if( m_iServeLocal )
												pResponse->strContent += "<img class=\"percent\" src=\"" + imagefill.strName + "\" width=" + CAtomInt( iPercent ).toString( ) + " height=8 alt=\"[" + gmapLANG_CFG["completed"] + "]\" name=\"Completed\" title=\"" + gmapLANG_CFG["completed"] + "\">";
										}

										if( iPercent < 100 )
										{
											// Modified by =Xotic=
											if( !imagetrans.strURL.empty( ) )
												pResponse->strContent += "<img class=\"percent\" src=\"" + imagetrans.strURL + imagetrans.strName + "\" width=" + CAtomInt( 100 - iPercent ).toString( ) + " height=8 alt=\"[" + gmapLANG_CFG["remaining"] + "]\" name=\"Remaining\" title=\"" + gmapLANG_CFG["remaining"] + "\">";
											else if( m_iServeLocal )
												pResponse->strContent += "<img class=\"percent\" src=\"" + imagetrans.strName + "\" width=" + CAtomInt( 100 - iPercent ).toString( ) + " height=8 alt=\"[" + gmapLANG_CFG["remaining"] + "]\" name=\"Remaining\" title=\"" + gmapLANG_CFG["remaining"] + "\">";
										}
									}
								}
								else
									// Modified by =Xotic=
									pResponse->strContent += UTIL_BytesToString( pTorrents[i].iAverageLeft ) + "%";

							}
							// Modified by =Xotic=
							pResponse->strContent += "</td>\n";
						}

						// <td> maxi left

						if( m_bShowMaxiLeft )
						{
							pResponse->strContent += "<td class=\"percent\">";

							if( pTorrents[i].iLeechers == 0 )
								// Modified by =Xotic=
								pResponse->strContent += gmapLANG_CFG["na"];
							else
							{
								if( m_pAllowed )
								{
									int iPercent = 0;

									if( pTorrents[i].iSize > 0 )
									{
										if( m_bShowLeftAsProgress )
											iPercent = 100 - (int)( ( (float)pTorrents[i].iMinLeft / pTorrents[i].iSize ) * 100 );
										else
											iPercent = (int)( ( (float)pTorrents[i].iMaxiLeft / pTorrents[i].iSize ) * 100 );
									}

									// Modified by =Xotic=
									pResponse->strContent += CAtomInt( iPercent ).toString( ) + "%";
								}
								else
									pResponse->strContent += UTIL_BytesToString( pTorrents[i].iMaxiLeft );
							}
							// Modified by =Xotic=
							pResponse->strContent += "</td>\n";
						}

						// <td> uploader

						if( m_bShowUploader )
							// Modified by =Xotic=
							pResponse->strContent += "<td class=\"uploader\">" + UTIL_RemoveHTML( pTorrents[i].strUploader ) + "</td>\n";

						// <td> info link

						if( m_bAllowInfoLink )
						{
							pResponse->strContent += "<td class=\"infolink\">";

							if( !pTorrents[i].strInfoLink.empty( ) )
								// Modified by =Xotic=
								pResponse->strContent += "<a rel=\"" + string( TARGET_REL ) + "\" title=\"" + gmapLANG_CFG["link"] + ": " + UTIL_RemoveHTML( pTorrents[i].strInfoLink ) + "\" href=\"" + UTIL_RemoveHTML( pTorrents[i].strInfoLink ) + "\">" + gmapLANG_CFG["link"] + "</a>";

							pResponse->strContent += "</td>\n";
						}

						// <td> admin

						if( pRequest->user.iAccess & ACCESS_EDIT )
						{
							if( m_pAllowed )
								// Modified by =Xotic=
								pResponse->strContent += "<td class=\"admin\">[<a title=\"" + gmapLANG_CFG["delete"] + ": " + UTIL_HashToString( pTorrents[i].strInfoHash ) + "\" href=\"/index.html?del=" + UTIL_HashToString( pTorrents[i].strInfoHash ) + "\">" + gmapLANG_CFG["delete"] + "</a>]</td>\n";        
						}

						pResponse->strContent += "</tr>\n";

						iAdded++;
					}
					else
						iSkipped++;
				}
			}

			delete [] pTorrents;

			// some finishing touches

			if( bFound )
				// Modified by =Xotic=
				pResponse->strContent += "</table>\n\n";

			if( m_pAllowed && m_bShowNames && m_bSearch )
			{
				// Modified by =Xotic=
				pResponse->strContent += "<form class=\"search_index\" name=\"bottomsearch\" method=\"get\" action=\"/index.html\">\n";

				if( !strSort.empty( ) )
					// Modified by =Xotic=
					pResponse->strContent += "<p><input name=\"sort\" type=hidden value=\"" + strSort + "\"></p>\n";

				if( !strFilter.empty( ) )
					// Modified by =Xotic=
					pResponse->strContent += "<p><input name=\"filter\"type=hidden value=\"" + strFilter + "\"></p>\n";

				if( !strMode.empty( ) )
					pResponse->strContent += "<p><input name=\"mode\" type=hidden value=\"" + strMode + "\"></p>\n";

				// The Trinity Edition - Modification Begins
				// The following changes the descriptor of the search field from "Search" to "Torrent Search"
				// and changes the "Clear Search" link to read "Clear Filter and Search Results"
				// Paragraph Tags "<p> and </p>" are also added to further separate the Search Form from the Table of Torrents
				pResponse->strContent += "<p><label for=\"bottomtorrentsearch\">" + gmapLANG_CFG["torrent_search"] + "</label> <input name=\"search\" id=\"bottomtorrentsearch\" alt=\"[" + gmapLANG_CFG["torrent_search"] + "]\" type=text size=40> <a title=\"" + gmapLANG_CFG["clear_filter_search"] + "\" href=\"/index.html\">" + gmapLANG_CFG["clear_filter_search"] + "</a></p>\n";
				// ------------------------------------------------- End of Modification

				pResponse->strContent += "</form>\n\n";
				// ------------------------------------------------- End of Modification
			}

			// page numbers

			if( m_iPerPage > 0 )
			{
				// Modified by =Xotic=
				pResponse->strContent += "<p class=\"pagenum_bottom\">" + gmapLANG_CFG["jump_to_page"] + ": \n";

				for( unsigned long i = 0; i < (unsigned int)iFound; i += m_iPerPage )
				{
					pResponse->strContent += " ";

					// don't link to current page

					if( i != iStart )
					{
						pResponse->strContent += "<a title=\"" + gmapLANG_CFG["jump_to_page"] + ": " + CAtomInt( ( i / m_iPerPage ) + 1 ).toString( ) + "\" href=\"/index.html?page=" + CAtomInt( i / m_iPerPage ).toString( );

						if( !strSort.empty( ) )
							// Modified by =Xotic=
							pResponse->strContent += "&amp;sort=" + strSort;

						if( !strSearch.empty( ) )
							// Modified by =Xotic=
							pResponse->strContent += "&amp;search=" + strSearchResp;

						if( !strFilter.empty( ) )
							// Modified by =Xotic=
							pResponse->strContent += "&amp;filter=" + UTIL_StringToEscaped( strFilter );

						if( !strMode.empty( ) )
							pResponse->strContent += "&amp;mode=" + strMode;
						// ------------------------ End of Addition

						pResponse->strContent += "\">";
					}

					pResponse->strContent += CAtomInt( ( i / m_iPerPage ) + 1 ).toString( );

					if( i != iStart )
						// Modified by =Xotic=
						pResponse->strContent += "</a>\n";

					// don't display a bar after the last page

					if( i + (unsigned int)m_iPerPage < (unsigned int)iFound )
						// Modified by =Xotic=
						pResponse->strContent += "\n<span class=\"pipe\">|</span>";
				}

				pResponse->strContent += "</p>\n\n";
			}
		}         
		// Output common HTML ending
		HTML_Common_End( pRequest, pResponse, btv, IS_INDEX, string( CSS_INDEX ) );
		// --------------------------- End of Modification
	}
	else
	{
		// Modified by =Xotic=
		HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["index_page"], string( CSS_INDEX ), string( ), NOT_INDEX, CODE_401 );

		// Output common HTML ending
		HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_INDEX ) );
		// ---------------------- End of Modification
	}
}
