/***
*
* BNBT Beta 8.0 - A C++ BitTorrent Tracker
* Copyright (C) 2003-2004 Trevor Hogan
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
***/

// =Xotic= Modified Source File

#include "bnbt.h"
#include "atom.h"
#include "tracker.h"
#include "util.h"

// Added by =Xotic=
#include "xconfig_lang.h"
// --------------------- End of Addition

void CTracker :: serverResponseInfo( struct request_t *pRequest, struct response_t *pResponse )
{
	struct bnbttv btv = UTIL_CurrentTime( );

	if( pRequest->user.iAccess & ACCESS_VIEW )
	{
		time_t tNow = time( NULL );
		char *szTime = asctime( localtime( &tNow ) );
		szTime[strlen( szTime ) - 1] = '\0';
		int iInfo = 0;

		// Modified by =Xotic=
		HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["info_page"], string( CSS_INFO ), string( ), NOT_INDEX, CODE_200 );
	
		pResponse->strContent += "<div class=\"index_table\">\n";
		pResponse->strContent += "<table summary=\"tinfo\">\n";
		pResponse->strContent += "<tr><th colspan=2>" + gmapLANG_CFG["info_tracker_info"] + "</th></tr>\n";

		if( iInfo % 2 )
			pResponse->strContent += "<tr class=\"even\">";
		else
			pResponse->strContent += "<tr class=\"odd\">";

		pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_tracker_version"] + "</th>\n";
		pResponse->strContent += "<td class=\"info_field\">" + string( XBNBT_VER ) + "</td></tr>\n";

		iInfo++;
		if( iInfo % 2 )
			pResponse->strContent += "<tr class=\"even\">";
		else
			pResponse->strContent += "<tr class=\"odd\">";

		pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_server_time"] + "</th>\n";
		pResponse->strContent += "<td class=\"info_field\">" + string( szTime ) + "</td></tr>\n";

		iInfo++;
		if( iInfo % 2 )
			pResponse->strContent += "<tr class=\"even\">";
		else
			pResponse->strContent += "<tr class=\"odd\">";

		pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_uptime"] + "</th>\n";
		pResponse->strContent += "<td class=\"info_field\">" + UTIL_SecondsToString( GetTime( ) ) + "</td></tr>\n";

		if( !m_strDumpRSSTitle.empty( ) )
		{
			iInfo++;
			if( iInfo % 2 )
				pResponse->strContent += "<tr class=\"even\">";
			else
				pResponse->strContent += "<tr class=\"odd\">";

			pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_tracker_title"] + "</th>\n";
			pResponse->strContent += "<td class=\"info_field\">" + m_strXTitle + "</td></tr>\n";
		}

		if( !m_strDumpRSSDescription.empty( ) )
		{
			iInfo++;
			if( iInfo % 2 )
				pResponse->strContent += "<tr class=\"even\">";
			else
				pResponse->strContent += "<tr class=\"odd\">";

			pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_tracker_desc"] + "</th>\n";
			pResponse->strContent += "<td class=\"info_field\">" + m_strXDescription + "</td></tr>\n";
		}

		if( !m_strForceAnnounceURL.empty( ) )
		{
			iInfo++;
			if( iInfo % 2 )
				pResponse->strContent += "<tr class=\"even\">";
			else
				pResponse->strContent += "<tr class=\"odd\">";

			pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["forced_announce_url"] + "</th>\n";
			pResponse->strContent += "<td class=\"info_field\">" + UTIL_RemoveHTML( m_strForceAnnounceURL ) + "</td></tr>\n";
		}
		else {
			iInfo++;
			if( iInfo % 2 )
				pResponse->strContent += "<tr class=\"even\">";
			else
				pResponse->strContent += "<tr class=\"odd\">";

			pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["announce_url"] + "</th>\n";
			pResponse->strContent += "<td class=\"info_field\">http://";
			pResponse->strContent += "<script type=\"text/javascript\">document.write( parent.location.host );</script>";
			pResponse->strContent += "/announce</td></tr>\n";
		}

		iInfo++;
		if( iInfo % 2 )
			pResponse->strContent += "<tr class=\"even\">";
		else
			pResponse->strContent += "<tr class=\"odd\">";

		pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_torrent_size"] + "</th>\n";
		pResponse->strContent += "<td class=\"info_field\">" + UTIL_BytesToString( giMaxRecvSize ) + "</td></tr>\n";
		// ------------------------------------------------- End of Modification

		if( m_pDFile )
		{
			// Modified by =Xotic=
			iInfo++;
			if( iInfo % 2 )
				pResponse->strContent += "<tr class=\"even\">";
			else
				pResponse->strContent += "<tr class=\"odd\">";

			pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_torrents"] + "</th>\n";
			pResponse->strContent += "<td class=\"info_field\">" + CAtomLong( m_pDFile->getValuePtr( )->size( ) ).toString( ) + "</td></tr>\n";
			// ------------------------------------------------- End of Modification

			unsigned long iPeers = 0;

			map<string, CAtom *> *pmapDicti = m_pDFile->getValuePtr( );

			for( map<string, CAtom *> :: iterator i = pmapDicti->begin( ); i != pmapDicti->end( ); i++ )
			{
				if( (*i).second->isDicti( ) )
					iPeers += (unsigned long)( (CAtomDicti *)(*i).second )->getValuePtr( )->size( );
			}

			// Modified by =Xotic=
			if( !rssdump.strName.empty( ) )
			{
				iInfo++;
				if( iInfo % 2 )
					pResponse->strContent += "<tr class=\"even\">";
				else
					pResponse->strContent += "<tr class=\"odd\">";

				pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_rss"] + "</th>\n";

				pResponse->strContent += "<td class=\"info_field\">";

				if( !rssdump.strURL.empty( ) )
					pResponse->strContent += "<a title=\"" + gmapLANG_CFG["navbar_rss"] + "\" rel=\"" + string( TARGET_REL ) + "\" href=\"" + rssdump.strURL + rssdump.strName + "\">" + rssdump.strURL + rssdump.strName + "</a>";
				else if( m_iServeLocal )
					pResponse->strContent += "<script type=\"text/javascript\">" + m_strRSSLocalLink + "</script>";

				pResponse->strContent += "</td></tr>\n";
			}

			iInfo++;
			if( iInfo % 2 )
				pResponse->strContent += "<tr class=\"even\">";
			else
				pResponse->strContent += "<tr class=\"odd\">";

			pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_total_peers"] + "</th>\n";
			pResponse->strContent += "<td class=\"info_field\">" + CAtomLong( iPeers ).toString( ) + "</td></tr>\n";

			if( m_bCountUniquePeers )
			{
				iInfo++;
				if( iInfo % 2 )
					pResponse->strContent += "<tr class=\"even\">";
				else
					pResponse->strContent += "<tr class=\"odd\">";

				pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_unique_peers"] + "</th>\n";
				pResponse->strContent += "<td class=\"info_field\">" + CAtomLong( m_pIPs->getValuePtr( )->size( ) ).toString( ) + "</td></tr>\n";
			}
		}

		if( m_pUsers )
		{
			iInfo++;
			if( iInfo % 2 )
				pResponse->strContent += "<tr class=\"even\">";
			else
				pResponse->strContent += "<tr class=\"odd\">";

			pResponse->strContent += "<th class=\"info_field\">" + gmapLANG_CFG["info_reg_users"] + "</th>\n";
			pResponse->strContent += "<td class=\"info_field\">" + CAtomLong( m_pUsers->getValuePtr( )->size( ) ).toString( ) + "</td></tr>\n";
		}

		pResponse->strContent += "</table>\n";
		pResponse->strContent += "</div>\n";
		// ------------------------------------------------- End of Modification
	}
	else
		HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["info_page"], string( CSS_INFO ), string( ), NOT_INDEX, CODE_401 );

	// Modified by =Xotic=	
	// Output common HTML ending
	HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_INFO ) );
	// ---------------------- End of Modification
}
