/***
*
* BNBT Beta 8.0 - A C++ BitTorrent Tracker
* Copyright (C) 2003-2004 Trevor Hogan
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
***/

// =Xotic= Modified Source File

#include "bnbt.h"
#include "atom.h"
#include "md5.h"
#include "sort.h"
#include "tracker.h"
#include "util.h"

// Added by =Xotic=
#include "xmysqlusers.h"
#include "xconfig_lang.h"
// --------------------- End of Addition

void CTracker :: serverResponseUsers( struct request_t *pRequest, struct response_t *pResponse )
{
	struct bnbttv btv = UTIL_CurrentTime( );

	// Modified by =Xotic=
	// XBNBT MySQL Users Integration
	if( pRequest->user.iAccess & ACCESS_ADMIN )
	{
		HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["users_page"], string( CSS_USERS ), string( ), NOT_INDEX, CODE_200 );
	
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
		if( giMySQLUsersOverrideUsers )
		{
			pResponse->strContent += "<p class=\"mysql_users_info\">" + UTIL_Xsprintf( gmapLANG_CFG["users_load_success"].c_str( ), m_strMySQLUsersLoadLast.c_str( ) ) + "</p>\n";
			pResponse->strContent += "<p class=\"mysql_users_info\">" + UTIL_Xsprintf( gmapLANG_CFG["users_load_status"].c_str( ), m_strMySQLUsersLoadLastStatus.c_str( ) ) + "</p>\n";
			pResponse->strContent += "<p class=\"mysql_users_info\">" + UTIL_Xsprintf( gmapLANG_CFG["users_load_interval"].c_str( ), CAtomInt( m_iMySQLUsersLoadInterval ).toString( ).c_str( ) ) + "</p>\n";
		}
		else
		{
#endif
			//
			// create user
			//

			if( pRequest->mapParams.find( "us_login" ) != pRequest->mapParams.end( ) &&
				pRequest->mapParams.find( "us_password" ) != pRequest->mapParams.end( ) &&
				pRequest->mapParams.find( "us_password_verify" ) != pRequest->mapParams.end( ) &&
				pRequest->mapParams.find( "us_email" ) != pRequest->mapParams.end( ) )
			{
				string strLogin = pRequest->mapParams["us_login"];
				string strPass = pRequest->mapParams["us_password"];
				string strPass2 = pRequest->mapParams["us_password_verify"];
				string strMail = pRequest->mapParams["us_email"];
				string strAccView = pRequest->mapParams["us_access_view"];
				string strAccDL = pRequest->mapParams["us_access_dl"];
				string strAccComments = pRequest->mapParams["us_access_comments"];
				string strAccUpload = pRequest->mapParams["us_access_upload"];
				string strAccEdit = pRequest->mapParams["us_access_edit"];
				string strAccAdmin = pRequest->mapParams["us_access_admin"];
				string strAccSignup = pRequest->mapParams["us_access_signup"];

				if( strLogin.empty( ) || strPass.empty( ) || strPass2.empty( ) || strMail.empty( ) )
				{
					// Added by =Xotic=
					// The Trinity Edition - Modification Begins
					// Created Links to either "Make Corrections" or "Start Over"
					// when creating a NEW USER FAILS because ALL FIELDS WERE NOT FILLED IN
					pResponse->strContent += "<p class=\"failed_message_users\">" + gmapLANG_CFG["users_fields_create_fail"] + "</p>\n";
					pResponse->strContent += "<p class=\"failed_message_users\">" + gmapLANG_CFG["users_do_q"] + "</p>\n";
					pResponse->strContent += "<p class=\"failed_message_users\"><a title=\"" + gmapLANG_CFG["users_make_correct"] + "\" href=\"" + string( JS_BACK ) + "\">" + gmapLANG_CFG["users_make_correct"] + "</a><span class=\"pipe\">|</span><a title=\"" + gmapLANG_CFG["users_start_over"] + "\" href=\"/users.html\">" + gmapLANG_CFG["users_start_over"] + "</a></p>\n\n";                
					// ------------------------------------------------- End of Modification

					HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );

					return;
				}
				else
				{
					if( strPass == strPass2 )
					{
						if( m_pUsers->getItem( strLogin ) )
						{
							// Added by =Xotic=
							// The Trinity Edition - Modification Begins
							// Created Links to either "Make Corrections" or "Start Over"
							// when creating a NEW USER FAILS because THE USER ALREADY EXISTS
							pResponse->strContent += "<p class=\"failed_message_users\">" + UTIL_Xsprintf( gmapLANG_CFG["users_exists_create_fail"].c_str( ), UTIL_RemoveHTML( strLogin ).c_str( ) ) + "</p>\n";
							pResponse->strContent += "<p class=\"failed_message_users\">" + gmapLANG_CFG["users_do_q"] + "</p>\n";
							pResponse->strContent += "<p class=\"failed_message_users\"><a title=\"" + gmapLANG_CFG["users_make_correct"] + "\" href=\"" + string( JS_BACK ) + "\">" + gmapLANG_CFG["users_make_correct"] + "</a><span class=\"pipe\">|</span><a title=\"" + gmapLANG_CFG["users_start_over"] + "\" href=\"/users.html\">" + gmapLANG_CFG["users_start_over"] + "</a></p>\n\n";    

							// Output common HTML ending
							HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );
							// ---------------------- End of Modification

							return;
						}
						else
						{
							int iAccess = 0;

							if( strAccView == "on" )
								iAccess += ACCESS_VIEW;
							if( strAccDL == "on" )
								iAccess += ACCESS_DL;
							if( strAccComments == "on" )
								iAccess += ACCESS_COMMENTS;
							if( strAccUpload == "on" )
								iAccess += ACCESS_UPLOAD;
							if( strAccEdit == "on" )
								iAccess += ACCESS_EDIT;
							if( strAccAdmin == "on" )
								iAccess += ACCESS_ADMIN;
							if( strAccSignup == "on" )
								iAccess += ACCESS_SIGNUP;

							addUser( strLogin, strPass, iAccess, strMail );

							// Modified by =Xotic=  
							// The Trinity Edition - Modification Begins
							// The following places the Return to Users link in its own paragraph
							// as opposed to immediately following the "Created user..." message.
							pResponse->strContent += "<p class=\"created_message_users\">" + UTIL_Xsprintf( gmapLANG_CFG["users_created_user"].c_str( ), UTIL_RemoveHTML( strLogin ).c_str( ), string( "<a title=\"" + gmapLANG_CFG["navbar_users"] + "\" href=\"/users.html\">" ).c_str( ), "</a>" ) + "</p>\n";

							// Output common HTML ending
							HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );
							// ---------------------- End of Modification

							return;
						}
					}
					else
					{
						// Added by =Xotic=
						// The Trinity Edition - Modification Begins
						// Created Links to either "Make Corrections" or "Start Over"
						// when creating a NEW USER FAILS because THE PASSWORDS DO NOT MATCH
						pResponse->strContent += "<p class=\"failed_message_users\">" + gmapLANG_CFG["users_password_create_fail"] + "</p>\n";
						pResponse->strContent += "<p class=\"failed_message_users\">" + gmapLANG_CFG["users_do_q"] + "</p>\n";
						pResponse->strContent += "<p class=\"failed_message_users\"><a title=\"" + gmapLANG_CFG["users_make_correct"] + "\" href=\"" + string( JS_BACK ) + "\">" + gmapLANG_CFG["users_make_correct"] + "</a><span class=\"pipe\">|</span><a title=\"" + gmapLANG_CFG["users_start_over"] + "\" href=\"/users.html\">" + gmapLANG_CFG["users_start_over"] + "</a></p>\n\n";
						// ------------------------------------------------- End of Modification

						// Output common HTML ending
						HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );

						return;
					}
				}
			}
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
		}
#endif
		// -------------------------------------------- End of Modification

		//
		// edit user
		//

		string strPass = pRequest->mapParams["us_password"];
		string strPass2 = pRequest->mapParams["us_password_verify"];
		string strMail = pRequest->mapParams["us_email"];
		string strAccView = pRequest->mapParams["us_access_view"];
		string strAccDL = pRequest->mapParams["us_access_dl"];
		string strAccComments = pRequest->mapParams["us_access_comments"];
		string strAccUpload = pRequest->mapParams["us_access_upload"];
		string strAccEdit = pRequest->mapParams["us_access_edit"];
		string strAccAdmin = pRequest->mapParams["us_access_admin"];
		string strAccSignup = pRequest->mapParams["us_access_signup"];

		string strUser = UTIL_EscapedToString( UTIL_RemoveHTML( pRequest->mapParams["user"] ) );
		string strAction = pRequest->mapParams["action"];
		string strOK = pRequest->mapParams["ok"];

		if( strAction == "edit" )
		{
			CAtom *pUserToEdit = m_pUsers->getItem( strUser );

			if( pUserToEdit && pUserToEdit->isDicti( ) )
			{
				if( strOK == "1" )
				{
					// Modified by =Xotic=
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
					// XBNBT MySQL Users Integration
					// Begin Marker 2
					if( !giMySQLUsersOverrideUsers )
					{
#endif
						// edit password

						if( !strPass.empty( ) && !strPass2.empty( ) )
						{
							if( strPass == strPass2 )
							{
								string strA1 = strUser + ":" + gstrRealm + ":" + strPass;

								unsigned char szMD5[16];

								MD5_CTX md5;

								MD5Init( &md5 );
						    	MD5Update( &md5, (unsigned char *)strA1.c_str( ), (unsigned int)strA1.size( ) );
								MD5Final( szMD5, &md5 );

								( (CAtomDicti *)pUserToEdit )->setItem( "md5", new CAtomString( string( (char *)szMD5, 16 ) ) );
							}
							else
							{
								// Added by =Xotic=
								// The Trinity Edition - Modification Begins
								// Created Links to either "Make Corrections" or "Start Over"
								// when EDITING USER FAILS because THE PASSWORDS DO NOT MATCH
								pResponse->strContent += "<p class=\"failed_message_users\">" + gmapLANG_CFG["users_password_edit_fail"] + "</p>\n";
								pResponse->strContent += "<p class=\"failed_message_users\">" + gmapLANG_CFG["users_do_q"] + "</p>\n";
								pResponse->strContent += "<p class=\"failed_message_users\"><a title=\"" + gmapLANG_CFG["users_make_correct"] + "\" href=\"" + string( JS_BACK ) + "\">" + gmapLANG_CFG["users_make_correct"] + "</a><span class=\"pipe\">|</span><a title=\"" + gmapLANG_CFG["users_start_over"] + "\" href=\"/users.html\">" + gmapLANG_CFG["users_start_over"] + "</a></p>\n\n";
								// ------------------------------------------------- End of Modification

								// Modified by =Xotic=  
								// Output common HTML ending
								HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );
								// ---------------------- End of Modification

								return;
							}
						}

						// edit mail

						( (CAtomDicti *)pUserToEdit )->setItem( "email", new CAtomString( strMail ) );
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
					}
#endif
					// End Marker 2
					// ----------------------------------------- End of Modification

					// edit access

					int iAccess = 0;

					if( strAccView == "on" )
						iAccess += ACCESS_VIEW;
					if( strAccDL == "on" )
						iAccess += ACCESS_DL;
					if( strAccComments == "on" )
						iAccess += ACCESS_COMMENTS;
					if( strAccUpload == "on" )
						iAccess += ACCESS_UPLOAD;
					if( strAccEdit == "on" )
						iAccess += ACCESS_EDIT;
					if( strAccAdmin == "on" )
						iAccess += ACCESS_ADMIN;
					if( strAccSignup == "on" )
						iAccess += ACCESS_SIGNUP;

					( ( CAtomDicti * )pUserToEdit )->setItem( "access", new CAtomLong( iAccess ) );

					// Modified by -Xotic
#if defined XBNBT_MYSQL || BNBT_MYSQL
					// XBNBT MySQL Users Integration
					if( giMySQLUsersOverrideUsers )
						UTIL_SetMySQLUsersMemberAccess( strUser, iAccess );
					else
						// Original code
#endif
						saveUsers( );
					// ---------------------------------------- End of Modification
			
					// Modified by =Xotic=  
					// Edited user
					pResponse->strContent += "<p class=\"created_message_users\">" + UTIL_Xsprintf( gmapLANG_CFG["users_edited_user"].c_str( ), strUser.c_str( ) , string( "<a title=\"" + gmapLANG_CFG["navbar_users"] + "\" href=\"/users.html\">" ).c_str( ), "</a>" ) + "</p>\n\n" ;

					// Output common HTML ending
					HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );
					// ---------------------- End of Modification

					return;
				}
				else
				{
					int iAccess = 0;

					CAtom *pAccessToEdit = ( (CAtomDicti *)pUserToEdit )->getItem( "access" );

					if( pAccessToEdit && dynamic_cast<CAtomLong *>( pAccessToEdit ) )
						iAccess = (int)dynamic_cast<CAtomLong *>( pAccessToEdit )->getValue( );

					pResponse->strContent += "<div class=\"edit_users\">\n";
					pResponse->strContent += "<table class=\"edit_users\">\n";
					pResponse->strContent += "<tr class=\"edit_users\">\n";
					pResponse->strContent += "<td class=\"edit_users\">\n";
					pResponse->strContent += "<form method=\"get\" name=\"editusers\" action=\"/users.html\">\n";

					// Modified by =Xotic=
					// Edit User
					pResponse->strContent += "<p class=\"edit_users\">" + UTIL_Xsprintf( gmapLANG_CFG["users_editing_user"].c_str( ), strUser.c_str( ) ) + "</p>\n\n" ;
					// -------------------------------- End of Modification

					pResponse->strContent += "<div class=\"edit_input_users\"><input name=\"user\" type=hidden value=\"" + strUser + "\"></div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\"><input name=\"action\" type=hidden value=\"edit\"></div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\"><input name=\"ok\" type=hidden value=1></div>\n";

					// Modified by =Xotic=
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
					// XBNBT MySQL Users Integration
					if( !giMySQLUsersOverrideUsers )
					{
						// Original code
						pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_password\" name=\"us_password\" alt=\"[" + gmapLANG_CFG["users_password"] + "]\" type=password size=20> <label for=\"id_password\">" + gmapLANG_CFG["users_password"] + "</label><br></div>\n";
						pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_verify_password\" name=\"us_password_verify\" alt=\"[" + gmapLANG_CFG["users_verify_password"] + "]\" type=password size=20> <label for=\"id_verify_password\">" + gmapLANG_CFG["users_verify_password"] + "</label><br><br></div>\n";
						pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_email\" name=\"us_email\" alt=\"[" + gmapLANG_CFG["email"] + "]\" type=text size=40";                   
					}
#else
					// Original code
					pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_password\" name=\"us_password\" alt=\"[" + gmapLANG_CFG["users_password"] + "]\" type=password size=20> <label for=\"id_password\">" + gmapLANG_CFG["users_password"] + "</label><br></div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_verify_password\" name=\"us_password_verify\" alt=\"[" + gmapLANG_CFG["users_verify_password"] + "]\" type=password size=20> <label for=\"id_verify_password\">" + gmapLANG_CFG["users_verify_password"] + "</label><br><br></div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_email\" name=\"us_email\" alt=\"[" + gmapLANG_CFG["email"] + "]\" type=text size=40";                   
#endif
					CAtom *pMailToEdit = ( (CAtomDicti *)pUserToEdit )->getItem( "email" );

#if defined XBNBT_MYSQL || defined BNBT_MYSQL
					// XBNBT MySQL Users Integration
					if( giMySQLUsersOverrideUsers )
					{
						if( pMailToEdit )
							pResponse->strContent += "<a title=\"" + pMailToEdit->toString( ) + "\" href=\"mailto:" + pMailToEdit->toString( ) + "\">" + pMailToEdit->toString( ) + "</a><br><br></div>\n";
					}
					else
					{
#endif
						// Original code
						if( pMailToEdit )
							pResponse->strContent += " value=\"" + pMailToEdit->toString( ) + "\"";

						pResponse->strContent += "> <label for=\"id_email\">" + gmapLANG_CFG["email"] + "</label><br><br></div>\n";
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
					}
#endif
					// --------------------------- End of Modification

					pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_view\" name=\"us_access_view\" alt=\"[" + gmapLANG_CFG["users_view_access"] + "]\" type=checkbox";

					if( iAccess & ACCESS_VIEW )
						pResponse->strContent += " checked";

					pResponse->strContent += "> <label for=\"id_view\">" + gmapLANG_CFG["users_view_access"] + "</label><br></div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_download\" name=\"us_access_dl\" alt=\"[" + gmapLANG_CFG["users_dl_access"] + "]\" type=checkbox";

					if( iAccess & ACCESS_DL )
						pResponse->strContent += " checked";

					pResponse->strContent += "> <label for=\"id_download\">" + gmapLANG_CFG["users_dl_access"] + "</label><br></div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_comments\" name=\"us_access_comments\" alt=\"[" + gmapLANG_CFG["users_comments_access"] + "]\" type=checkbox";

					if( iAccess & ACCESS_COMMENTS )
						pResponse->strContent += " checked";

					pResponse->strContent += "> <label for=\"id_comments\">" + gmapLANG_CFG["users_comments_access"] + "</label><br></div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_upload\" name=\"us_access_upload\"  alt=\"[" + gmapLANG_CFG["users_upload_access"] + "]\"type=checkbox";

					if( iAccess & ACCESS_UPLOAD )
						pResponse->strContent += " checked";

					pResponse->strContent += "> <label for=\"id_upload\">" + gmapLANG_CFG["users_upload_access"] + "</label><br></div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_edit\" name=\"us_access_edit\" alt=\"[" + gmapLANG_CFG["users_edit_access"] + "]\" type=checkbox";

					if( iAccess & ACCESS_EDIT )
						pResponse->strContent += " checked";

					pResponse->strContent += "> <label for=\"id_edit\">" + gmapLANG_CFG["users_edit_access"] + "</label><br></div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_admin\" name=\"us_access_admin\" alt=\"[" + gmapLANG_CFG["users_admin_access"] + "]\" type=checkbox";

					if( iAccess & ACCESS_ADMIN )
						pResponse->strContent += " checked";

					pResponse->strContent += "> <label for=\"id_admin\">" + gmapLANG_CFG["users_admin_access"] + "</label><br></div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\"><input id=\"id_signup\" name=\"us_access_signup\" alt=\"[" + gmapLANG_CFG["users_signup_access"] + "]\" type=checkbox";

					if( iAccess & ACCESS_SIGNUP )
						pResponse->strContent += " checked";

					pResponse->strContent += "> <label for=\"id_signup\">" + gmapLANG_CFG["users_signup_access"] + "</label><br><br></div>\n";

					// Added by =Xotic=
					// The Trinity Edition - Addition Begins
					// The following creates a CANCEL EDIT button
					// when EDITING A USER                  pResponse->strContent += "<div>\n";
					pResponse->strContent += "<div class=\"edit_input_users\">\n";
					Button_Submit( "submit_edit", string( gmapLANG_CFG["edit_user"] ), pResponse );
					Button_Back( "cancel_edit", string( gmapLANG_CFG["cancel"] ), pResponse );
					pResponse->strContent += "\n</div>\n";
					// ------------------------------------------------- End of Addition                    

					pResponse->strContent += "</form>\n";
					pResponse->strContent += "</td>\n";
					pResponse->strContent += "</tr>\n";
					pResponse->strContent += "</table>\n";
					pResponse->strContent += "</div>\n";

					// Modified by =Xotic=  
					// Output common HTML ending
					HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );
					// ---------------------- End of Modification
					return;
				}
			}
			else
			{
				// Modified by =Xotic=  
				// The Trinity Edition - Modification Begins
				// Modified the "Return to Users Page" to use BROWSER BACK
				// as opposed to reloading the Users Page
				// when EDITING USER FAILS because THE USER DOES NOT EXIST
				pResponse->strContent += "<p class=\"created_message_users\">" + UTIL_Xsprintf( gmapLANG_CFG["users_edit_nouser"].c_str( ), strUser.c_str( ) ) + "</p>\n\n" ;
				pResponse->strContent += "<p class=\"failed_message_users\"><a title=\"" + gmapLANG_CFG["previous_page"] + "\" href=\"" + string( JS_BACK ) + "\">" + gmapLANG_CFG["previous_page"] + "</a></p>\n";

				// Output common HTML ending
				HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );
				// ---------------------- End of Modification

				return;
			}
		}

		//
		// delete user
		//

		else if( strAction == "delete" )
		{
			// Modified by +xotic
			// Begin Marker 3
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
			if( !giMySQLUsersOverrideUsers )
			{
#endif
				if( strOK == "1" )
				{
					deleteUser( strUser );
				
					// Modified by =Xotic=  
					// Deleted user
					pResponse->strContent += "<p class=\"deleted_users\">" + UTIL_Xsprintf( gmapLANG_CFG["users_deleted_user"].c_str( ), strUser.c_str( ), string( "<a title=\"" + gmapLANG_CFG["navbar_users"] + "\" href=\"/users.html\">" ).c_str( ), "</a>" ) + "</p>\n\n" ;

					// Output common HTML ending
					HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );
					// ---------------------- End of Modification

					return;
				}
				else
				{
					// Modified by =Xotic=  
					// The Trinity Edition - Modification Begins
					// The following replaces the OK response with a YES | NO option
					// when DELETING A USER
					// Are you sure you want to delete the user
					pResponse->strContent += "<p class=\"delete\">" + UTIL_Xsprintf( gmapLANG_CFG["users_delete_q"].c_str( ), strUser.c_str( ) ) + "</p>\n\n" ;
					pResponse->strContent += "<p class=\"delete\"><a title=\"" + gmapLANG_CFG["yes"] + "\" href=\"/users.html?user=" + strUser + "&amp;action=delete&amp;ok=1\">" + gmapLANG_CFG["yes"] + "</a> | <a title=\"" + gmapLANG_CFG["no"] + "\" href=\"" + string( JS_BACK ) + "\">" + gmapLANG_CFG["no"] + "</a></p>\n";

					// Output common HTML ending
					HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );
					// ---------------------- End of Modification

					return;
				}
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
			}
#endif
			// End of Marker 3
			// -------------------------- End of Modification
		}

		// Modified by =Xotic=
		// XBNBT MySQL Users Integration
		// Begin Marker4
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
		if( !giMySQLUsersOverrideUsers )
		{
#endif
			//
			// create user
			//
			pResponse->strContent += "<div class=\"create_users\">\n";
			pResponse->strContent += "<table class=\"create_users\">\n";
			pResponse->strContent += "<tr class=\"create_users\">\n";
			pResponse->strContent += "<td class=\"create_users\">\n";
			pResponse->strContent += "<form method=\"get\" name=\"createusers\" action=\"/users.html\">\n";
			pResponse->strContent += "<p class=\"create_users\">" + gmapLANG_CFG["users_create_user_title"] + "</p>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_login\" name=\"us_login\" alt=\"[" + gmapLANG_CFG["login"] + "]\" type=text size=24> <label for=\"id_login\">" + gmapLANG_CFG["login"] + "</label><br><br></div>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_password\" name=\"us_password\" alt=\"[" + gmapLANG_CFG["password"] + "]\" type=password size=20> <label for=\"id_password\">" + gmapLANG_CFG["password"] + "</label><br></div>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_verify\" name=\"us_password_verify\" alt=\"[" + gmapLANG_CFG["verify_password"] + "]\" type=password size=20> <label for=\"id_verify\">" + gmapLANG_CFG["verify_password"] + "</label><br><br></div>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_email\" name=\"us_email\" alt=\"[" + gmapLANG_CFG["email"] + "]\" type=text size=40> <label for=\"id_email\">" + gmapLANG_CFG["email"] + "</label><br><br></div>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_view\" name=\"us_access_view\" alt=\"[" + gmapLANG_CFG["users_view_access"] + "]\" type=checkbox> <label for=\"id_view\">" + gmapLANG_CFG["users_view_access"] + "</label><br></div>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_download\" name=\"us_access_dl\" alt=\"[" + gmapLANG_CFG["users_dl_access"] + "]\" type=checkbox> <label for=\"id_download\">" + gmapLANG_CFG["users_dl_access"] + "</label><br></div>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_comments\" name=\"us_access_comments\" alt=\"[" + gmapLANG_CFG["users_comments_access"] + "]\" type=checkbox> <label for=\"id_comments\">" + gmapLANG_CFG["users_comments_access"] + "</label><br></div>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_upload\" name=\"us_access_upload\" alt=\"[" + gmapLANG_CFG["users_upload_access"] + "]\" type=checkbox> <label for=\"id_upload\">" + gmapLANG_CFG["users_upload_access"] + "</label><br></div>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_edit\" name=\"us_access_edit\" alt=\"[" + gmapLANG_CFG["users_edit_access"] + "]\" type=checkbox> <label for=\"id_edit\">" + gmapLANG_CFG["users_edit_access"] + "</label><br></div>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_admin\" name=\"us_access_admin\" alt=\"[" + gmapLANG_CFG["users_admin_access"] + "]\" type=checkbox> <label for=\"id_admin\">" + gmapLANG_CFG["users_admin_access"] + "</label><br></div>\n";
			pResponse->strContent += "<div class=\"input_create_users\"><input id=\"id_signup\" name=\"us_access_signup\" alt=\"[" + gmapLANG_CFG["users_signup_access"] + "]\" type=checkbox> <label for=\"id_signup\">" + gmapLANG_CFG["users_signup_access"] + "</label><br><br></div>\n";
			// Added by =Xotic=
			// Adds Cancel button beside Create User
			pResponse->strContent += "<div class=\"create_users_buttons\">\n";
			Button_Submit( "submit_create", string( gmapLANG_CFG["create_user"] ), pResponse );
			Button_Back( "cancel_create", string( gmapLANG_CFG["cancel"] ), pResponse );
			pResponse->strContent += "\n</div>\n";
			// ------------------------------------------------- End of Modification
			pResponse->strContent += "</form>\n";
			pResponse->strContent += "</td>\n";
			pResponse->strContent += "</tr>\n";
			pResponse->strContent += "</table>\n";
			pResponse->strContent += "</div>\n";
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
		}
#endif
		// End Marker4
		// --------------------------------- End of Modification

		//
		// user table
		//

		if( m_pUsers )
		{
			if( m_pUsers->isEmpty( ) )
			{
				pResponse->strContent += "<p class=\"no_users\">" + gmapLANG_CFG["users_nousers_warning"] + "</p>\n";

				// Modified by =Xotic=  
				// Output common HTML ending
				HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );
				// ---------------------- End of Modification

				return;
			}

			map<string, CAtom *> *pmapDicti = m_pUsers->getValuePtr( );

			unsigned long iKeySize = (unsigned long)pmapDicti->size( );

			// add the users into this structure one by one and sort it afterwards

			struct user_t *pUsersT = new struct user_t[iKeySize];

			unsigned long i = 0;

			for( map<string, CAtom *> :: iterator it = pmapDicti->begin( ); it != pmapDicti->end( ); it++ )
			{
				pUsersT[i].strLogin = (*it).first;
				pUsersT[i].strLowerLogin = UTIL_ToLower( pUsersT[i].strLogin );
				pUsersT[i].iAccess = m_iGuestAccess;

				if( (*it).second->isDicti( ) )
				{
					CAtom *pMD5 = ( (CAtomDicti *)(*it).second )->getItem( "md5" );
					CAtom *pAccess = ( (CAtomDicti *)(*it).second )->getItem( "access" );
					CAtom *pMail = ( (CAtomDicti *)(*it).second )->getItem( "email" );
					CAtom *pCreated = ( (CAtomDicti *)(*it).second )->getItem( "created" );

					if( pMD5 )
						pUsersT[i].strMD5 = pMD5->toString( );

					if( pMail )
					{
						pUsersT[i].strMail = pMail->toString( );
						pUsersT[i].strLowerMail = UTIL_ToLower( pUsersT[i].strMail );
					}

					if( pAccess && dynamic_cast<CAtomLong *>( pAccess ) )
						pUsersT[i].iAccess = (int)dynamic_cast<CAtomLong *>( pAccess )->getValue( );

					if( pCreated )
						pUsersT[i].strCreated = pCreated->toString( );
				}

				i++;
			}

			string strSort = pRequest->mapParams["sort"];

			if( !strSort.empty( ) )
			{
				int iSort = atoi( strSort.c_str( ) );

				// Modified by =Xotic=
				// Sort code cleanup
				switch ( iSort )
				{
				case SORTU_ALOGIN:
					qsort( pUsersT, iKeySize, sizeof( struct user_t ), asortuByLogin );
					break;
				case SORTU_AACCESS:
					qsort( pUsersT, iKeySize, sizeof( struct user_t ), asortuByAccess );
					break;
				case SORTU_AEMAIL:
					qsort( pUsersT, iKeySize, sizeof( struct user_t ), asortuByMail );
					break;
				case SORTU_ACREATED:
					qsort( pUsersT, iKeySize, sizeof( struct user_t ), asortuByCreated );
					break;
				case SORTU_DLOGIN:
					qsort( pUsersT, iKeySize, sizeof( struct user_t ), dsortuByLogin );
					break;
				case SORTU_DACCESS:
					qsort( pUsersT, iKeySize, sizeof( struct user_t ), dsortuByAccess );
					break;
				case SORTU_DEMAIL:
					qsort( pUsersT, iKeySize, sizeof( struct user_t ), dsortuByMail );
					break;
				case SORTU_DCREATED:
				default:
					qsort( pUsersT, iKeySize, sizeof( struct user_t ), dsortuByCreated );
				}
				// ----------------------------- End of Modification
			}
			else
			{
				// default action is to sort by created

				qsort( pUsersT, iKeySize, sizeof( struct user_t ), dsortuByCreated );
			}

			// some preliminary search crap

			string strSearch = pRequest->mapParams["search"];
			string strLowerSearch = UTIL_ToLower( strSearch );
			string strSearchResp = UTIL_StringToEscaped( strSearch );

			// Modified by =Xotic=
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
			// XBNBT MySQL Users Integration
			if( !giMySQLUsersOverrideUsers )
#endif
				pResponse->strContent += "\n<hr class=\"users_hr\">\n\n";
			// --------------------------------------- End of Modification

			// page numbers
			int iFoundx = 0;

			if( m_iUsersPerPage > 0 )
			{
				// for correct page numbers after searching
				int iFound = 0;

				if( !strSearch.empty( ) )
				{
					// Modified by =Xotic=
					for( unsigned long i = 0; i < iKeySize; i++ )
					{
						// only display entries that match the search
						if( pUsersT[i].strLowerLogin.find( strLowerSearch ) == string :: npos )
							continue;

						iFound++;
					}

					// Search results for:
					pResponse->strContent += "<p class=\"search_results\">" + UTIL_Xsprintf( gmapLANG_CFG["search_results_for"].c_str( ), string( "\"<span class=\"filtered_by\">" + UTIL_RemoveHTML( strSearch ) + "</span>\"").c_str( ) ) + "</p>\n";
					// -------------------------- End of Modification
				}
				else
					iFound=iKeySize;

				// Modified by =Xotic=
				switch( iFound )
				{
				case 0:
					pResponse->strContent += "<p class=\"results\">" + gmapLANG_CFG["result_none_found"] + "</p>\n";
					break;
				case 1:
					pResponse->strContent += "<p class=\"results\">" + gmapLANG_CFG["result_1_found"] + "</p>\n";
					break;
				default:
					// Results Found
					pResponse->strContent += "<p class=\"results\">" + UTIL_Xsprintf( gmapLANG_CFG["result_x_found"].c_str( ), CAtomInt( iFound ).toString( ).c_str( ) ) + "</p>\n";
				}
				// -------------------------- End of Modification

				iFoundx=iFound;
			}
			// -------------------------------- End of Modification

			// which page are we viewing

			unsigned int iStart = 0;

			if( m_iUsersPerPage > 0 )
			{
				string strPage = pRequest->mapParams["page"];

				if( !strPage.empty( ) )
					iStart = atoi( strPage.c_str( ) ) * m_iUsersPerPage;

				// Added by =Xotic=
				// The Trinity Edition - Modification Begins
				// The following changes the CSS class from "pagenum_top" to "pagenum_top_users" 
				// so that differing styles can be applied to page numbers on ONLY the Users Page
				// You are viewing page
				pResponse->strContent += "<p class=\"pagenum_top_users\">" + UTIL_Xsprintf( gmapLANG_CFG["viewing_page_num"].c_str( ), CAtomInt( ( iStart / m_iUsersPerPage ) + 1 ).toString( ).c_str( ) ) + "</p>\n";
				// ------------------------------------------------- End of Modification
			}

			bool bFound = false;

			int iAdded = 0;
			int iSkipped = 0;

			// for correct page numbers after searching

			int iFound = 0;

			for( unsigned long i = 0; i < iKeySize; i++ )
			{
				if( !strSearch.empty( ) )
				{
					// only display entries that match the search

					if( pUsersT[i].strLowerLogin.find( strLowerSearch ) == string :: npos )
						continue;
				}

				iFound++;

				if( m_iUsersPerPage == 0 || iAdded < m_iUsersPerPage )
				{
					if( !bFound )
					{
						// output table headers

						// Added by =Xotic=
						// The Trinity Edition - Addition Begins
						// The following inserts a User Search Field BEFORE the User Listing
						// The form has been copied from the one below, but...
						// "Search" has been replaced by "User Search", and
						// "Clear Search" has been replaced by "Clear Search Results"

						// Added paragraph tags
						pResponse->strContent += "<form class=\"search_users_top\" name=\"topsearch\" method=\"get\" action=\"/users.html\">\n";

						if( !strSort.empty( ) )
							pResponse->strContent += "<p><input name=\"sort\" type=hidden value=\"" + strSort + "\"></p>\n";

						pResponse->strContent += "<p class=\"search_users\"><label for=\"topusersearch\">" + gmapLANG_CFG["user_search"] + "</label> <input id=\"topusersearch\" name=\"search\" alt=\"[" + gmapLANG_CFG["user_search"] + "]\" type=text size=40> <a title=\"" + gmapLANG_CFG["clear_filter_search"] + "\" href=\"/users.html\"> " + gmapLANG_CFG["clear_filter_search"] + "</a></p>\n";
						pResponse->strContent += "</form>\n";

						// The following adds the CSS class "pagenum_top_bar_users" 
						// so that differing styles can be applied to page numbers on ONLY the Users Page
						// "Jump to Page" has also been added before Page Navigation
						pResponse->strContent += "<p class=\"pagenum_top_bar_users\">" + gmapLANG_CFG["jump_to_page"] + " ";

						for( unsigned long i = 0; i < (unsigned int)iFoundx; i += m_iUsersPerPage )
						{
							pResponse->strContent += " ";

							// don't link to current page
							if( i != iStart )
							{
								pResponse->strContent += "<a title=\"" + gmapLANG_CFG["jump_to_page"] + ": " + CAtomInt( ( i / m_iUsersPerPage ) + 1 ).toString( ) + "\" href=\"/users.html?page=" + CAtomInt( i / m_iUsersPerPage ).toString( );

								if( !strSort.empty( ) )
									pResponse->strContent += "&amp;sort=" + strSort;
								//pResponse->strContent += "&sort=" + strSort;

								if( !strSearch.empty( ) )
									pResponse->strContent += "&amp;search=" + strSearchResp;
								//pResponse->strContent += "&search=" + strSearchResp;

								pResponse->strContent += "\">";
							}

							pResponse->strContent += CAtomInt( ( i / m_iUsersPerPage ) + 1 ).toString( );

							if( i != iStart )
								pResponse->strContent += "</a>";

							pResponse->strContent += " ";

							// don't display a bar after the last page
							if( i + (unsigned int)m_iUsersPerPage < (unsigned int)iFoundx )
								pResponse->strContent += "|";
						}

						pResponse->strContent += "</p>\n";
						// -------------------------------- End of Addition

						// Modified by =Xotic=
						pResponse->strContent += "<div class=\"users_table\">\n";
						pResponse->strContent += "<table summary=\"users\">\n";
						// -------------------------------- End of Modification

						pResponse->strContent += "<tr><th class=\"name\">" + gmapLANG_CFG["login"];
						pResponse->strContent += "<br><a title=\"" + gmapLANG_CFG["sort_login_ascending"] + "\" class=\"sort\" href=\"/users.html?sort=" + SORTUSTR_ALOGIN;

						if( !strSearch.empty( ) )
							pResponse->strContent += "&amp;search=" + strSearchResp;

						pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a title=\"" + gmapLANG_CFG["sort_login_descending"] + "\" class=\"sort\" href=\"/users.html?sort=" + SORTUSTR_DLOGIN;

						if( !strSearch.empty( ) )
							pResponse->strContent += "&amp;search=" + strSearchResp;

						pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a>";
						pResponse->strContent += "</th><th>" + gmapLANG_CFG["access"];
						pResponse->strContent += "<br><a title=\"" + gmapLANG_CFG["sort_access_ascending"] + "\" class=\"sort\" href=\"/users.html?sort=" + SORTUSTR_AACCESS;

						if( !strSearch.empty( ) )
							pResponse->strContent += "&amp;search=" + strSearchResp;

						pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a title=\"" + gmapLANG_CFG["sort_access_descending"] + "\" class=\"sort\" href=\"/users.html?sort=" + SORTUSTR_DACCESS;

						if( !strSearch.empty( ) )
							pResponse->strContent += "&amp;search=" + strSearchResp;

						pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a>";
						pResponse->strContent += "</th><th>" + gmapLANG_CFG["email"];
						pResponse->strContent += "<br><a title=\"" + gmapLANG_CFG["sort_email_ascending"] + "\" class=\"sort\" href=\"/users.html?sort=" + SORTUSTR_AEMAIL;

						if( !strSearch.empty( ) )
							pResponse->strContent += "&amp;search=" + strSearchResp;

						pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a title=\"" + gmapLANG_CFG["sort_email_descending"] + "\" class=\"sort\" href=\"/users.html?sort=" + SORTUSTR_DEMAIL;

						if( !strSearch.empty( ) )
							pResponse->strContent += "&amp;search=" + strSearchResp;

						pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a>";
						pResponse->strContent += "</th><th>" + gmapLANG_CFG["created"];
						pResponse->strContent += "<br><a title=\"" + gmapLANG_CFG["sort_created_ascending"] + "\" class=\"sort\" href=\"/users.html?sort=" + SORTUSTR_ACREATED;

						if( !strSearch.empty( ) )
							pResponse->strContent += "&amp;search=" + strSearchResp;

						pResponse->strContent += "\">" + gmapLANG_CFG["sort_ascending"] + "</a><span>-</span><a title=\"" + gmapLANG_CFG["sort_created_descending"] + "\" class=\"sort\" href=\"/users.html?sort=" + SORTUSTR_DCREATED;

						if( !strSearch.empty( ) )
							pResponse->strContent += "&amp;search=" + strSearchResp;

						pResponse->strContent += "\">" + gmapLANG_CFG["sort_descending"] + "</a>";
						pResponse->strContent += "</th><th>" + gmapLANG_CFG["admin"] + "</th></tr>\n";

						bFound = true;
					}

					if( iSkipped == (int)iStart )
					{
						// output table rows

						if( iAdded % 2 )
							pResponse->strContent += "<tr class=\"even\">";
						else
							pResponse->strContent += "<tr class=\"odd\">";

						pResponse->strContent += "<td class=\"name\">";
						pResponse->strContent += UTIL_RemoveHTML( pUsersT[i].strLogin );
						pResponse->strContent += "</td><td>";
						pResponse->strContent += UTIL_AccessToString( pUsersT[i].iAccess );
						pResponse->strContent += "</td><td>";
						// Added by =Xotic=
						// The Trinity Edition - Modification Begins
						// The following makes user email addresses HYPERLINKED
						pResponse->strContent += "<a title=\"" + UTIL_RemoveHTML( pUsersT[i].strMail ) + "\" href=\"mailto:"; 
						pResponse->strContent += UTIL_RemoveHTML( pUsersT[i].strMail ); 
						pResponse->strContent += "\">"; 
						pResponse->strContent += UTIL_RemoveHTML( pUsersT[i].strMail );
						pResponse->strContent += "</a>"; 
						pResponse->strContent += "</td><td>";
						// ------------------------------------------------- End of Modification

						if( !pUsersT[i].strCreated.empty( ) )
						{
						// strip year and seconds from time

							pResponse->strContent += pUsersT[i].strCreated.substr( 5, pUsersT[i].strCreated.size( ) - 8 );
						}

						// Modified by =Xotic=
						// XBNBT MySQL Users Integration
#if defined XBNBT_MYSQL || defined BNBT_MYSQL
						if( giMySQLUsersOverrideUsers )
							pResponse->strContent += "</td><td>[<a title=\"" + gmapLANG_CFG["edit"] + "\" href=\"/users.html?user=" + UTIL_StringToEscaped( pUsersT[i].strLogin ) + "&amp;action=edit\">" + gmapLANG_CFG["edit"] + "</a>]</td></tr>\n";
						else    
#endif
							pResponse->strContent += "</td><td>[<a title=\"" + gmapLANG_CFG["edit"] + "\" href=\"/users.html?user=" + UTIL_StringToEscaped( pUsersT[i].strLogin ) + "&amp;action=edit\">" + gmapLANG_CFG["edit"] + "</a>] [<a title=\"" + gmapLANG_CFG["delete"] + "\" href=\"/users.html?user=" + UTIL_StringToEscaped( pUsersT[i].strLogin ) + "&amp;action=delete\">" + gmapLANG_CFG["delete"] + "</a>]</td></tr>\n";
						// ------------------------------------ End of Modification

						iAdded++;
					}
					else
						iSkipped++;
				}
			}

			delete [] pUsersT;

			// some finishing touches

			// Modified by =Xotic=
			if( bFound )
			{
				pResponse->strContent += "</table>\n";
				pResponse->strContent += "</div>\n";
			}
			// ----------------------------- End of Modification

			// Added and modified by =Xotic=
			// The Trinity Edition - Modification Begins
			// Horizontal Rules Line Added
			// "Search" has been replaced by "User Search", and
			// "Clear Search" has been replaced by "Clear Search Results"
			// Added paragraph tags
			pResponse->strContent += "<form class=\"search_users\" name=\"bottomsearch\" method=\"get\" action=\"/users.html\">\n";

			if( !strSort.empty( ) )
				pResponse->strContent += "<p><input name=\"sort\" type=hidden value=\"" + strSort + "\"></p>\n";

			pResponse->strContent += "<p class=\"search_users\"><label for=\"bottomusersearch\">" + gmapLANG_CFG["user_search"] + "</label> <input id=\"bottomusersearch\" name=\"search\" alt=\"[" + gmapLANG_CFG["user_search"] + "]\" type=text size=40> <a title=\"" + gmapLANG_CFG["clear_filter_search"] + "\" href=\"/users.html\"> " + gmapLANG_CFG["clear_filter_search"] + "</a></p>\n";
			pResponse->strContent += "</form>\n\n";
			// ------------------------------------------------- End of Modification

			// page numbers

			if( m_iUsersPerPage > 0 )
			{

				// Added by =Xotic=
				// The Trinity Edition - Modification Begins
				// The following changes the CSS class from "pagenum_bottom" to "pagenum_bottom_users" 
				// so that differing styles can be applied to page numbers on ONLY the Users Page
				// "Jump to Page" has also been added before Page Navigation
				pResponse->strContent += "<p class=\"pagenum_bottom_users\">" + gmapLANG_CFG["jump_to_page"] + " ";
				// ------------------------------------------------- End of Modification


				for( unsigned long i = 0; i < (unsigned int)iFound; i += m_iUsersPerPage )
				{
					pResponse->strContent += " ";

					// don't link to current page

					if( i != iStart )
					{
						pResponse->strContent += "<a title=\"" + gmapLANG_CFG["jump_to_page"] + ": " + CAtomInt( ( i / m_iUsersPerPage ) + 1 ).toString( ) + "\" href=\"/users.html?page=" + CAtomInt( i / m_iUsersPerPage ).toString( );

						if( !strSort.empty( ) )
							pResponse->strContent += "&amp;sort=" + strSort;

						if( !strSearch.empty( ) )
							pResponse->strContent += "&amp;search=" + strSearchResp;

						pResponse->strContent += "\">";
					}

					pResponse->strContent += CAtomInt( ( i / m_iUsersPerPage ) + 1 ).toString( );

					if( i != iStart )
						pResponse->strContent += "</a>";

					pResponse->strContent += " ";

					// don't display a bar after the last page

					if( i + (unsigned int)m_iUsersPerPage < (unsigned int)iFound )
						pResponse->strContent += "|";
				}

				pResponse->strContent += "</p>\n\n";
			}
		}
	}
	else
		HTML_Common_Begin(  pRequest, pResponse, gmapLANG_CFG["users_page"], string( CSS_USERS ), string( ), NOT_INDEX, CODE_401 );

	// Modified by =Xotic=  
	// Output common HTML ending
	HTML_Common_End( pRequest, pResponse, btv, NOT_INDEX, string( CSS_USERS ) );
	// ---------------------- End of Modification
}
