/***
*
* XBNBT Beta 81b.3.4 - A C++ BitTorrent Tracker
* Copyright (C) 2003-2004 =Xotic=
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
***/

// Modified by =Xotic=, from bnbt.h

#ifndef XBNBT_H
 #define XBNBT_H

#ifdef WIN32
 typedef unsigned __int8 uint8;
#else
 typedef unsigned char uint8;
 typedef unsigned long int DWORD;
 typedef unsigned short int WORD;
 typedef unsigned char BYTE;
#endif

// mutex

#ifdef WIN32
 #include <windows.h>
 #include <process.h>
#else
 #include <pthread.h>
#endif

class CMutex
{
public:
#ifdef WIN32
	void Initialize( ) { InitializeCriticalSection( &cs ); }
	void Destroy( ) { DeleteCriticalSection( &cs ); }
	void Claim( ) { EnterCriticalSection( &cs ); }
	void Release( ) { LeaveCriticalSection( &cs ); }

	CRITICAL_SECTION cs;
#else
	void Initialize( ) { pthread_mutex_init( &mtx, NULL ); }
	void Destroy( ) { pthread_mutex_destroy( &mtx ); }
	void Claim( ) { pthread_mutex_lock( &mtx ); }
	void Release( ) { pthread_mutex_unlock( &mtx ); }

	pthread_mutex_t mtx;
#endif
};				   

// XBNBT
#define XBNBT_VER "XBNBT 81b.3.4"

// The Trinity Edition - Modification Begins
// Sets the NT Service Name variable as a global variable
extern string gstrNTServiceName;

// XBNBT MySQL Users Integration
extern int giMySQLUsersOverrideUsers;
extern int giMySQLUsersMemberAccess;
extern string gstrMySQLUsersTable;
extern string gstrMySQLUsersAdmin;

// Threads
extern CMutex gmtxOutput;	

extern string gstrLinkEstDate;
// ------------------------------------- End Of Modification

#endif
