/***
*
* XBNBT Beta 81b.3.4 - A C++ BitTorrent Tracker
* Copyright (C) 2003-2004 =Xotic=
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
***/

// Modified by =Xotic=, from bnbt_mysql.h

#ifndef XMYSQLUSERS_H
 #define XMYSQLUSERS_H

#if defined XBNBT_MYSQL || defined BNBT_MYSQL

#ifdef WIN32
 #include <mysql.h>
#else 
 #ifdef __FREEBSD__
  #include </usr/local/include/mysql/mysql.h> 
 #else
  #include <mysql/mysql.h>
 #endif
#endif

extern MYSQL *gpMySQLUsers;
extern string gstrMySQLUsersHost;
extern string gstrMySQLUsersDatabase;
extern string gstrMySQLUsersUser;
extern string gstrMySQLUsersPassword;
extern string gstrMySQLUsersTable;
extern string gstrMySQLUsersAdmin;
extern int giMySQLUsersPort;
extern int giMySQLUsersOverrideUsers;
extern int giMySQLUsersMemberAccess;
extern string gstrMySQLUsersName;

void UTIL_InitMySQLUsersVars();
bool UTIL_StartMySQLUsers( );
string UTIL_StringToMySQLUsers( const string &strString );
bool UTIL_OpenMySQLUsers(void);
bool UTIL_TestMySQLUsersColumn(void);
bool UTIL_SetMySQLUsersMemberDefaultAccess(void);
bool UTIL_SetMySQLUsersMemberAccess( string strMySQLUsersMember, int iMySQLUsersAccess );
bool UTIL_CreateMySQLUsersColumn(void);
bool UTIL_CloseMySQLUsers(void);

class CMySQLUsersQuery
{
public:
	CMySQLUsersQuery( string strQuery );
	virtual ~CMySQLUsersQuery( );

	vector<string> nextRow( );
private:
	MYSQL_RES *m_pRes;
};

#endif

#endif
