/***
*
* XBNBT Beta 81b.3.4 - A C++ BitTorrent Tracker
* Copyright (C) 2003-2004 =Xotic=
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
***/

// Modified by =Xotic=, from sort.cpp

#include "bnbt.h"
#include "xsort.h"
#include "tracker.h"
#include "util.h"

int asortByTag( const void *elem1, const void *elem2 )
{
	return ( (struct torrent_t *)elem1 )->strTag.compare( ( (struct torrent_t *)elem2 )->strTag );
}

int dsortByTag( const void *elem1, const void *elem2 )
{
	return ( (struct torrent_t *)elem2 )->strTag.compare( ( (struct torrent_t *)elem1 )->strTag );
}

int asortpByClient( const void *elem1, const void *elem2 )
{
	return ( (struct peer_t *)elem1 )->strClientType.compare( ( (struct peer_t *)elem2 )->strClientType );
}

int dsortpByClient( const void *elem1, const void *elem2 )
{
	return ( (struct peer_t *)elem2 )->strClientType.compare( ( (struct peer_t *)elem1 )->strClientType );
}

int asortpByIP( const void *elem1, const void *elem2 )
{
	return ( (struct peer_t *)elem1 )->strIP.compare( ( (struct peer_t *)elem2 )->strIP );
}

int dsortpByIP( const void *elem1, const void *elem2 )
{
	return ( (struct peer_t *)elem2 )->strIP.compare( ( (struct peer_t *)elem1 )->strIP );
}

int asortpByAUR( const void *elem1, const void *elem2 )
{
	struct peer_t *peer1 = (struct peer_t *)elem1;
	struct peer_t *peer2 = (struct peer_t *)elem2;
		
	if( ( peer1->iUpped / peer1->iConnected ) < ( peer2->iUpped / peer2->iConnected ) )
		return 1;
	else if( ( peer1->iUpped / peer1->iConnected ) > ( peer2->iUpped / peer2->iConnected ) )
		return -1;
	else
		return 0;
}

int dsortpByAUR( const void *elem1, const void *elem2 )
{
	struct peer_t *peer1 = (struct peer_t *)elem1;
	struct peer_t *peer2 = (struct peer_t *)elem2;
		
	if( ( peer2->iUpped / peer2->iConnected ) < ( peer1->iUpped / peer1->iConnected ) )
		return 1;
	else if( ( peer2->iUpped / peer2->iConnected ) > ( peer1->iUpped / peer1->iConnected ) )
		return -1;
	else
		return 0;
}

int asortpByADR( const void *elem1, const void *elem2 )
{
	struct peer_t *peer1 = (struct peer_t *)elem1;
	struct peer_t *peer2 = (struct peer_t *)elem2;
		
	if( ( peer1->iDowned / peer1->iConnected ) < ( peer2->iDowned / peer2->iConnected ) )
		return 1;
	else if( ( peer1->iDowned / peer1->iConnected ) > ( peer2->iDowned / peer2->iConnected ) )
		return -1;
	else
		return 0;;
}

int dsortpByADR( const void *elem1, const void *elem2 )
{
	struct peer_t *peer1 = (struct peer_t *)elem1;
	struct peer_t *peer2 = (struct peer_t *)elem2;
		
	if( ( peer2->iDowned / peer2->iConnected ) < ( peer1->iDowned / peer1->iConnected ) )
		return 1;
	else if( ( peer2->iDowned / peer2->iConnected ) > ( peer1->iDowned / peer1->iConnected ) )
		return -1;
	else
		return 0;
}

int asortByUploader( const void *elem1, const void *elem2 )
{
	return ( (struct torrent_t *)elem1 )->strUploader.compare( ( (struct torrent_t *)elem2 )->strUploader );
}

int dsortByUploader( const void *elem1, const void *elem2 )
{
	return ( (struct torrent_t *)elem2 )->strUploader.compare( ( (struct torrent_t *)elem1 )->strUploader );
}
