/***
*
* XBNBT Beta 81b.3.4 - A C++ BitTorrent Tracker
* Copyright (C) 2003-2004 =Xotic=
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
***/

// Modified by =Xotic=, from tracker.h

#ifndef XTRACKER_H
 #define XTRACKER_H

// XBNBT
#define TARGET_REL "external"
#define TARGET_BLANK "_blank"
#define DOC_TYPE "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n"
#define CSS_LOGIN "login"
#define CSS_INDEX "index"
#define CSS_ADMIN "admin"
#define CSS_SIGNUP "signup"
#define CSS_USERS "users"
#define CSS_INFO "info"
#define CSS_STATS "stats"
#define CSS_UPLOAD "upload"
#define CSS_COMMENTS "comments"
#define JS_BACK "javascript:history.back();"
#define JS_CHECKLENGTH "javascript:checklength( document.form );"
#define LANG_BUF_LEN 512
#define IS_INDEX true
#define NOT_INDEX false
#define CODE_200 0
#define CODE_401 1

// Server response codes
// For Server response statistics
#define RESPONSE_INIT		0
#define RESPONSE_ANNOUNCE	1
#define RESPONSE_SCRAPE		2
#define RESPONSE_FAVICON	3
#define RESPONSE_CSS		4
#define RESPONSE_RSS		5
#define RESPONSE_XML		6
#define RESPONSE_ROBOTS		7
#define RESPONSE_INDEX		8
#define RESPONSE_STATS		9
#define RESPONSE_LOGIN		10
#define RESPONSE_SIGNUP		11
#define RESPONSE_UPLOAD		12
#define RESPONSE_INFO		13
#define RESPONSE_ADMIN		14
#define RESPONSE_USERS		15
#define RESPONSE_COMMENTS	16
#define RESPONSE_TORRENTS	17
#define RESPONSE_FILES		18
#define RESPONSE_IMAGEFILL	19
#define RESPONSE_IMAGETRANS	20

// XBNBT Dynstat
#define PNG_FORMAT	0
#define JPG_FORMAT	1
#define GIF_FORMAT	2
#define UNK_FORMAT	3
#define IMAGE_BY_INFOHASH 0
#define IMAGE_BY_FILENAME 1
#define IMAGE_ERROR_OK 0
#define IMAGE_ERROR_NAME 1
#define IMAGE_ERROR_TYPE 2
#define IMAGE_ERROR_EXIST 3

// XBNBT Validators
#define VALID_ADMIN	0
#define VALID_TEXT	1
#define VALID_IMAGE 2

// XBNBT Structure for holding file details
struct localfile_t
{
	string strName;
	string strExt;
	string strDir;
	string strFile;
	string strURL;
};

// XBNBT Structure for holding text in Dynstat
struct dynstat_t
{
	string strTitle;
	string strSize;
	string strFiles;
	string strTag;
	string strHash;
	string strFilename;
	//string strAdded;
	string strSeeders;
	string strLeechers;
	string strStats;
	string strPeers;
	string strLogo;
	string strImageFileName;
	string strImageFullPath;
};

// XBNBT Structure for holding announce stats
struct announcestats_t
{
	int64 iAnnounce;
	int64 iCompact;
	int64 iNopeerid;
	int64 iRegular;
	int64 iIPBanned;
	int64 iIPNotCleared;
	//int64 iIPNATBlocked;
	//int64 iIPLocalOnly;
	int64 iPeerSpoofRestrict;
	int64 iClientBanned;
	int64 iInvalidEvent;
	int64 iPortMissing;
	int64 iUploadedMissing;
	int64 iDownloadedMissing;
	int64 iLeftMissing;
	int64 iPeerIDLength;
	int64 iPortBlacklisted;
	int64 iDownloadedInvalid;
	int64 iUploadedInvalid;
	string sLastReset;
};

// XBNBT Structure for holding scrape stats
struct scrapestats_t
{
	int64 iScrape;
	int64 iSingle;
	int64 iFull;
	string sLastReset;
};

// XBNBT Structure for holding Dynstat stats
struct dynstatstats_t
{
	int64 iRun;
	int64 iFrozen;
	int64 iProcessed;
	int64 iTotalProcessed;
	string sLastRunTime;
	string sElapsedTime;
	string sLastReset;
};

// XBNBT Structure for holding served file stats
struct filestats_t
{
	int64 iFavicon;
	int64 iCSS;
	int64 iRSS;
	int64 iXML;
	int64 iRobots;
	int64 iFiles;
	int64 iBarFill;
	int64 iBarTrans;
	string sLastReset;
};

// XBNBT Structure for holding page hit count stats
struct pagestats_t
{
	int64 iIndex;
	int64 iStats;
	int64 iLogin;
	int64 iSignup;
	int64 iUpload;
	int64 iInfo;
	int64 iAdmin;
	int64 iUsers;
	int64 iComments;
	int64 iTorrents;
	int64 iError404;
	string sLastReset;
};

// XBNBT Structure for holding date stats
struct datestats_t
{
	string sLinkEstablished;
	string sRSSPublish;
	string sXMLPublish;
	string sCountUniquePeers;
};

// XBNBT Structure for holding all system stats
struct xbnbtstats_t
{
	// dynstat
	struct dynstatstats_t dynstat;
	// announce
	struct announcestats_t announce;
	// scrape
	struct scrapestats_t scrape;
	// files served
	struct filestats_t file;
	// html pages
	struct pagestats_t page;
	// Sessional date stamps
	struct datestats_t date;
};

#endif
